
DEFINT A-Z

TYPE ObjType
   XSize AS INTEGER
   YSize AS INTEGER
   p AS INTEGER
   X AS INTEGER
   Y AS INTEGER
   DX AS INTEGER
   DY AS INTEGER
   Damage AS INTEGER
   g AS INTEGER
END TYPE

TYPE Weapon
   Shipp AS INTEGER
   Shotp AS INTEGER
   ShotDelay AS INTEGER
   Automatic AS INTEGER
   Damage AS INTEGER
   Avail AS INTEGER
   MaxAmmo AS INTEGER
END TYPE

TYPE Colour
   Red AS INTEGER
   Green AS INTEGER
   Blue AS INTEGER
END TYPE


DECLARE SUB CheckValid ()
DECLARE SUB HelpScreen ()
DECLARE SUB StatusScreen ()
DECLARE SUB Init ()
DECLARE SUB InitStars ()
DECLARE SUB StarPalLoop (C AS INTEGER, st AS INTEGER)
DECLARE SUB GetPics ()
DECLARE SUB NewLevel ()
DECLARE SUB DispHiScores ()
DECLARE SUB EndOfGame ()
DECLARE SUB InterpretLev ()
DECLARE SUB NewEnemy (X AS INTEGER, Y AS INTEGER, p AS INTEGER, g AS INTEGER)
DECLARE SUB NewBoss ()
DECLARE SUB NewStar (n AS INTEGER)
DECLARE SUB NewGoodie (x1 AS INTEGER, y1 AS INTEGER, n AS INTEGER)
DECLARE SUB NewEnShot (p AS INTEGER, Dam AS INTEGER, X AS INTEGER, Y AS INTEGER, DX AS INTEGER, DY AS INTEGER)
DECLARE SUB MoveShip ()
DECLARE SUB MoveShots ()
DECLARE SUB MoveGoodies ()
DECLARE SUB MoveEnemies ()
DECLARE SUB MoveBoss ()
DECLARE SUB MoveEnShots ()
DECLARE SUB MoveStars ()
DECLARE SUB MoveStars2 (BGCol AS INTEGER)
DECLARE SUB HitEnemy (Enn AS INTEGER, Shn AS INTEGER, s AS INTEGER)
DECLARE SUB ShiftEn (n AS INTEGER)
DECLARE SUB EnMotion (t AS INTEGER, Ch AS INTEGER, xmax AS INTEGER, ymax AS INTEGER)
DECLARE SUB ShiftMB (n AS INTEGER)
DECLARE SUB ShiftBoss ()
DECLARE SUB CheckEnPos (n AS INTEGER)
DECLARE SUB CheckMBPos (n AS INTEGER)
DECLARE SUB CheckPos (n AS INTEGER, d AS INTEGER)
DECLARE SUB DoKeys ()
DECLARE SUB DoSound (A AS INTEGER, B AS INTEGER)
DECLARE SUB FireShot ()
DECLARE SUB Explode (x1 AS INTEGER, y1 AS INTEGER, DX1 AS INTEGER, DY1 AS INTEGER, s AS INTEGER, Linked AS INTEGER)
DECLARE SUB ShPal ()
DECLARE SUB Blank (x1 AS INTEGER, y1 AS INTEGER, s1 AS INTEGER, s2 AS INTEGER)
DECLARE FUNCTION EnShoot (n AS INTEGER)
DECLARE FUNCTION ValidShot (t AS INTEGER)
DECLARE FUNCTION Dist (O1 AS ObjType, O2 AS ObjType)
DECLARE FUNCTION NextByte ()
DECLARE FUNCTION NextFreeObj (A() AS ObjType, Min AS INTEGER, Max AS INTEGER)
DECLARE SUB BitArray (i AS INTEGER, Arr() AS INTEGER)
DECLARE SUB Text (Batch AS INTEGER, x1 AS INTEGER, y1 AS INTEGER, x2 AS INTEGER, y2 AS INTEGER, Message AS STRING, Col AS INTEGER)
DECLARE SUB RotateFontPal (Batch AS INTEGER)
DECLARE SUB VPutINT (x1 AS INTEGER, y1 AS INTEGER, A() AS INTEGER, el AS LONG, Mode AS INTEGER, MinY AS INTEGER, MaxY AS INTEGER)
DECLARE SUB SetPalette (PalArray() AS Colour, C1 AS INTEGER, C2 AS INTEGER)

CONST MaxObj = 20
CONST MaxShots = 20
CONST MaxEnShots = 30
CONST MaxGoodies = 10

OPTION BASE 0

DIM SHARED Pal(255) AS Colour
DIM SHARED FontPal(1 TO 20, 1 TO 4) AS INTEGER

DIM SHARED GameMode AS INTEGER
DIM SHARED Level AS INTEGER
DIM SHARED LevelData(1 TO 800) AS INTEGER
DIM SHARED LevCounter AS INTEGER
DIM SHARED Counter AS INTEGER
DIM SHARED CounterDat AS INTEGER ' what Counter is actually counting for.
DIM SHARED SaveLevel AS INTEGER
DIM SHARED LastGoodie AS INTEGER

DIM SHARED FontPics(34 * 96 * 3) AS INTEGER' 8 x 8 = 68 bytes
DIM SHARED ShipPics(202 * 8) AS INTEGER ' 20 x 20 = 404 bytes
DIM SHARED EnPics(202 * 10) AS INTEGER
DIM SHARED EnDams(202 * 10) AS INTEGER
DIM SHARED MBPics(802 * 10) AS INTEGER ' 40 x 40 = 1604 bytes
DIM SHARED MBDams(802 * 10) AS INTEGER
DIM SHARED BossPics(1752 * 4) AS INTEGER ' 70 x 50 = 3504 bytes
DIM SHARED BossDams(1752 * 4) AS INTEGER
DIM SHARED B5FPics(135 * 2) AS INTEGER' 14 x 19 = 270 bytes
DIM SHARED ShotPics(52 * 10) AS INTEGER ' 10 x 10 = 104 bytes
DIM SHARED LasPics(107 * 5) AS INTEGER ' 5 x 42 = 214 bytes
DIM SHARED ZapPics(1752) AS INTEGER ' 10 x 350 = 3504 bytes
DIM SHARED EnShotPics(52 * 10) AS INTEGER
DIM SHARED LExplodePics(100 * 4) AS INTEGER ' 14 x 14 = 200 bytes
DIM SHARED LExplodeMasks(100 * 4)  AS INTEGER
DIM SHARED BExplodePics(394 * 7)  AS INTEGER ' 14 x 14 = 788 bytes
DIM SHARED BExplodeMasks(394 * 7)  AS INTEGER
DIM SHARED GoodiesPics(52 * 8) AS INTEGER

DIM SHARED FontWidth(95) AS INTEGER
DIM SHARED K(1 TO 5) AS INTEGER
DIM SHARED Bits1(7)  AS INTEGER
DIM SHARED Bits2(7) AS INTEGER
DIM SHARED Sounds(1 TO 4, 1 TO 10) AS STRING
DIM SHARED Snd AS INTEGER

DIM SHARED Ship AS ObjType
DIM SHARED Shields AS INTEGER, Bombs AS INTEGER
DIM SHARED Lives AS INTEGER, Speed AS INTEGER
DIM SHARED CurrWeap AS INTEGER, Dead AS INTEGER
DIM SHARED ShotsFired AS LONG
DIM SHARED ShotsHit AS LONG
DIM SHARED NoHits AS INTEGER
DIM SHARED NoDeath AS INTEGER
DIM SHARED Score AS LONG
DIM SHARED Weap(1 TO 10) AS Weapon
DIM SHARED ShieldPal(1 TO 3, 0 TO 15) AS Colour
DIM SHARED LasPal(0 TO 10) AS LONG

DIM SHARED ShotCount AS INTEGER
DIM SHARED ShotOK AS INTEGER

DIM SHARED Goodies(1 TO MaxGoodies + 1) AS ObjType
DIM SHARED Stars(1 TO 100) AS ObjType
DIM SHARED Enemies(1 TO MaxObj + 1) AS ObjType ' enemies and explosions
DIM SHARED EnData(1 TO 3, 1 TO 20) AS INTEGER
DIM SHARED EnShotData(-1 TO 4) AS INTEGER
DIM SHARED ScoreData(-5 TO 20) AS INTEGER
DIM SHARED Boss AS ObjType
DIM SHARED BossData(5) AS INTEGER
DIM SHARED BossExtra(1 TO 10)  AS INTEGER
DIM SHARED BossMoves(1 TO 5, 1 TO 3) AS INTEGER
DIM SHARED MBMoves(1 TO 4, 1 TO 3) AS INTEGER


DIM SHARED Shots1(1 TO MaxShots + 1) AS ObjType' your shots
DIM SHARED Shots2(1 TO MaxEnShots + 1) AS ObjType' enemies' shots

DIM SHARED MaxEn AS INTEGER
DIM SHARED NumEn AS INTEGER
DIM SHARED NumMB AS INTEGER
DIM SHARED NumStars AS INTEGER
DIM SHARED ShootChance AS INTEGER
DIM SHARED GoodieChance AS INTEGER

DIM SHARED Ex1 AS INTEGER ' exit status
DIM SHARED OldLocks AS INTEGER ' original status of caps, scroll, num locks
DIM SHARED OP AS INTEGER ' old PEEK(284)
DIM SHARED SB AS INTEGER ' shoot buffer
DIM SHARED BombWait AS INTEGER ' delay until another bomb may be used
DIM SHARED PFC AS INTEGER ' palette flash counter
DIM SHARED FontPC(0 TO 2) AS INTEGER ' font palette counter
DIM SHARED FontCol(0 TO 2) AS Colour ' current font colour -- 1 to 7
'                             1 . . . . RED
'                             2 . . . . GREEN
'                             3 . . . . yellow
'                             4 . . . . BLUE
'                             5 . . . . purple
'                             6 . . . . cyan
'                             7 . . . . white

DIM SHARED En8(1 TO MaxObj) AS INTEGER ' counter for laser shooter
DIM SHARED TextDat(45, 1 TO 4) AS INTEGER
DIM SHARED TextStr(45) AS STRING

' CHDIR "d:\qb\starfire"

   CheckValid
   Init



   DO
      OP = PEEK(284): DEF SEG

      DoKeys

      MoveStars
      MoveGoodies
      MoveShip
      IF CounterDat = 12 THEN MoveBoss
      MoveEnemies
      MoveShots
      FireShot
      MoveEnShots

      Text 0, 0, 0, 0, 0, STR$(Score), 2

      IF Weap(CurrWeap).Avail / Weap(CurrWeap).MaxAmmo < .1 THEN
         Text 2, 124, 192, 0, 0, "* ammo low *", 1
         RotateFontPal 2
      END IF


      IF GameMode = 0 THEN
         IF CounterDat = 0 THEN
            InterpretLev
         ELSE
            SELECT CASE CounterDat
               CASE 1, 10
               CASE ELSE
                  Counter = Counter - 1
                  IF Counter <= 0 THEN
                     IF CounterDat = 255 THEN NewLevel ELSE CounterDat = 0
                  END IF
            END SELECT
         END IF
      ELSE
         s1! = SQR(Score)
         IF NumEn < MaxEn THEN
            IF NumMB OR RND > s1! / 5000 THEN
               t2 = INT(RND * 8 + 1): IF t2 = 8 THEN t2 = 9
               NewEnemy INT(RND * 280 + 20), 10, t2, 0
            ELSE
               NewEnemy INT(RND * 280 + 20), -20, INT(RND * 4) * 2 + 11, 10
               ShootChance = SQR(s1!) * 3: IF ShootChance > 100 THEN ShootChance = 100
               GoodieChance = s1! / 50 + 10: IF GoodieChance > 50 THEN GoodieChance = 50
               MaxEn = 1 + LOG(Score) / LOG(10): IF MaxEn < 5 THEN MaxEn = 5
            END IF
         END IF
      END IF
     
      IF PFC THEN PFC = PFC - 1: PALETTE 0, PFC * 12 * 65793
      IF BombWait THEN BombWait = BombWait - 1
  
      DEF SEG = 53
      DO: LOOP UNTIL PEEK(284) <> OP

   LOOP UNTIL Ex1 OR Dead = -1
   'Ex1 = 0
   EndOfGame
   Ex1 = 0
DEF SEG

OPEN "starfire.tmp" FOR OUTPUT AS #1
PRINT #1, OldLocks, -2 - Dead, Score
CLOSE #1
CHAIN "intro"

SUB BitArray (i AS INTEGER, Arr() AS INTEGER) STATIC

p = 256
FOR t = 7 TO 0 STEP -1
   p = p \ 2
   Arr(t) = -(p AND i)
NEXT t

END SUB

SUB Blank (x1 AS INTEGER, y1 AS INTEGER, s1 AS INTEGER, s2 AS INTEGER) STATIC

IF s2 = 0 THEN s2 = s1
LINE (x1 - s1, y1 - s2)-(x1 + s1, y1 + s2), 0, BF

END SUB

SUB CheckEnPos (n AS INTEGER) STATIC
IF Enemies(n).X < 10 THEN
   Enemies(n).X = 10: Enemies(n).DX = -Enemies(n).DX
ELSEIF Enemies(n).X > 309 THEN
   Enemies(n).X = 309: Enemies(n).DX = -Enemies(n).DX
END IF
IF Enemies(n).Y < 10 THEN
   Enemies(n).Y = 10: Enemies(n).DY = -Enemies(n).DY
ELSEIF Enemies(n).Y > 150 THEN
   Enemies(n).Y = 150: Enemies(n).DY = -Enemies(n).DY
END IF
END SUB

SUB CheckMBPos (n AS INTEGER) STATIC
IF Enemies(n).X < 20 THEN
   Enemies(n).X = 20: Enemies(n).DX = -Enemies(n).DX
ELSEIF Enemies(n).X > 299 THEN
   Enemies(n).X = 299: Enemies(n).DX = -Enemies(n).DX
END IF
IF Enemies(n).Y < 30 THEN
   Enemies(n).Y = Enemies(n).Y + 1: Enemies(n).DY = Enemies(n).DY + 1
ELSEIF Enemies(n).Y > 70 THEN
   Enemies(n).Y = 70: Enemies(n).DY = -Enemies(n).DY
END IF
END SUB

SUB CheckPos (n AS INTEGER, d AS INTEGER) STATIC

IF Enemies(n).X < d THEN
   Enemies(n).X = d
ELSEIF Enemies(n).X > 319 - d THEN
   Enemies(n).X = 319 - d
END IF
IF Enemies(n).Y < d THEN
   Enemies(n).Y = d
ELSEIF Enemies(n).Y > 199 - d THEN
   Enemies(n).Y = 199 - d
END IF

END SUB

SUB CheckValid

'   Ex1 = -1
'   PRINT "This program can only be run through the main executable." '''''''
   OPEN "starfire.tmp" FOR RANDOM AS #1 LEN = 20
   FIELD #1, 20 AS f$: GET #1, 1
   IF f$ = STRING$(20, 0) THEN ' file does not exist
      CLOSE #1
      CHAIN "intro"
   END IF
   CLOSE #1
   OPEN "starfire.tmp" FOR INPUT AS #1: CLS
   Ex1 = 0
   INPUT #1, OldLocks, GameMode
   CLOSE #1
   KILL "starfire.tmp"

END SUB

SUB DispHiScores

DIM HiNames(1 TO 10) AS STRING * 16
DIM HiScores(1 TO 10) AS STRING * 8


OPEN "hiscore.dat" FOR INPUT AS #1
FOR t = 1 TO 10
   INPUT #1, HiNames(t), HiScores(t)
NEXT t
CLOSE #1

Text 0, 54, 10, 0, 0, "name", 1
Text 0, 208, 10, 0, 0, "score", 1
FOR t = 1 TO 10
   sc$ = HiScores(t)
   DO UNTIL LEFT$(sc$, 1) <> "0" OR LEN(sc$) = 1
      sc$ = RIGHT$(sc$, LEN(sc$) - 1)
   LOOP
   Text 1, 54, t * 15 + 15, 0, 0, HiNames(t), 2
   Text 2, 208, t * 15 + 15, 0, 0, sc$, 3
NEXT t

   DO: LOOP UNTIL INKEY$ = ""
   C = 0
   DO
      OP = PEEK(284): DEF SEG
      C = C + 1
    
      StarPalLoop C, 1
   LOOP UNTIL INKEY$ <> ""


END SUB

FUNCTION Dist (O1 AS ObjType, O2 AS ObjType) STATIC

D1 = ABS(O1.X - O2.X)
D2 = ABS(O1.Y - O2.Y)
IF D2 > D1 THEN Dist = D2 ELSE Dist = D1

END FUNCTION

SUB DoKeys STATIC

' conventional input

   i$ = INKEY$
   IF LEN(i$) THEN
      IF LEN(i$) = 1 THEN i$ = UCASE$(i$)
      SELECT CASE i$
         CASE " ", "B", CHR$(0) + CHR$(48), CHR$(2)' devastation bomb
            IF Bombs > 0 AND BombWait = 0 AND Dead = 0 THEN
               DoSound 1, 10
               ShotsFired = ShotsFired + 1
               Bombs = Bombs - 1
               BombWait = 20
               t = NextFreeObj(Shots1(), 0, MaxShots)
               IF t THEN
                  Shots1(t).p = 7
                  Shots1(t).Damage = 10
                  Shots1(t).X = Ship.X
                  Shots1(t).Y = Ship.Y - 10
                  Shots1(t).XSize = 10: Shots1(t).YSize = 10
                  XX = (160 - Ship.X) \ 2
                  YY = (75 - Ship.Y)
                  Shots1(t).DX = -(6 * XX) \ YY
                  Shots1(t).DY = -5
               END IF
            END IF
         CASE CHR$(9), CHR$(0) + CHR$(15), "Z", CHR$(0) + CHR$(44), CHR$(26)' change weapon
            DoSound 4, 10
            CurrWeap = (3 * (1 + (CurrWeap - 1) \ 3)) MOD 9
            FOR t = CurrWeap TO CurrWeap - 2
               IF Weap(CurrWeap).Avail THEN EXIT FOR
            NEXT t
            DO
               CurrWeap = (CurrWeap MOD 9) + 1
            LOOP UNTIL Weap(CurrWeap).Avail
            DO UNTIL Weap(CurrWeap + 1).Avail = 0 OR CurrWeap MOD 3 = 0
               CurrWeap = CurrWeap + 1
            LOOP
            LINE (124, 192)-(200, 199), 0, BF ' remove "ammo low" sign
         CASE "S", CHR$(0) + CHR$(60)   ' toggle sound
            Snd = 1 - Snd
            IF Snd = 0 THEN s$ = "SOUND OFF" ELSE s$ = "SOUND ON"
            REDIM Temp(1200) AS INTEGER: GET (110, 69)-(210, 91), Temp(0)
            LINE (113, 74)-(207, 86), 0, BF
            FOR t = -3 TO 3
               LINE (113 + t, 72 + t)-(207 - t, 88 - t), 112 + ABS(t) * 3 + 5, B
            NEXT t
            Text 2, 158 - LEN(s$) * 4, 77, 0, 0, s$, 6: s$ = ""
            DO: LOOP UNTIL INKEY$ = ""
            t2 = 0: FontPC(2) = 0: RotateFontPal 2
            DEF SEG = 53
            DO
               t2 = t2 + 1
               OP = PEEK(284): DEF SEG
               StarPalLoop 1, 0
            LOOP UNTIL t2 > 16 OR INKEY$ <> ""
            PUT (110, 69), Temp(0), PSET
            DEF SEG
            'FontPC(1) = 0: RotateFontPal 1
         CASE "P", CHR$(0) + CHR$(25), CHR$(16), CHR$(13), CHR$(0) + CHR$(62)' pause game & display stats
            StatusScreen
            FontPC(0) = 20: RotateFontPal 0
         CASE "H", "?", CHR$(0) + CHR$(59)
            HelpScreen
            FontPC(0) = 20: RotateFontPal 0
         CASE CHR$(27), "Q", CHR$(0) + CHR$(68)
            REDIM Temp(1200) AS INTEGER: GET (110, 69)-(210, 91), Temp(0)
            LINE (113, 74)-(207, 86), 0, BF
            FOR t = -3 TO 3
               LINE (113 + t, 72 + t)-(207 - t, 88 - t), 112 + ABS(t) * 3 + 5, B
            NEXT t
            Text 2, 126, 77, 0, 0, "QUIT? Y/N", 3
            DO: LOOP UNTIL INKEY$ = ""
            t2 = 0: FontPC(2) = 1: Ex1 = 0
            DEF SEG = 53
            DO
               OP = PEEK(284): DEF SEG
               i$ = UCASE$(INKEY$)
               IF i$ = "N" OR i$ = CHR$(27) THEN Ex1 = 2
               IF i$ = "Y" THEN Ex1 = 1: Dead = -1
               StarPalLoop 1, 0
            LOOP UNTIL Ex1
            PUT (110, 69), Temp(0), PSET
            DEF SEG
            Ex1 = 2 - Ex1
         CASE CHR$(0) + CHR$(119)
            NewGoodie INT(RND * 300 + 10), 5, INT(RND * 7 + 1)
         CASE CHR$(0) + CHR$(132)
            Bombs = 10
            Speed = 10
            FOR t = 1 TO 9: Weap(t).Avail = Weap(t).MaxAmmo: NEXT t
         CASE CHR$(0) + CHR$(118)
            Shields = 15: ShPal
         CASE CHR$(0) + CHR$(117)
            IF ShotsFired = 0 THEN ShotsFired = 1
            NewLevel
      END SELECT
   END IF

' input from Shift, Alt, Ctrl

DEF SEG = 64
'POKE 24, (PEEK(24) AND 240)

BitArray PEEK(23), Bits1()
BitArray PEEK(24), Bits2()
DEF SEG

IF Bits1(0) OR Bits1(1) THEN K(1) = 1 ELSE K(1) = 0
IF (Bits1(2) AND NOT Bits2(0)) OR (Bits1(3) AND Bits2(1)) THEN K(5) = 1 ELSE K(5) = 0
IF (Bits1(3) AND NOT Bits2(1)) OR (Bits1(2) AND Bits2(0)) THEN K(4) = 1 ELSE K(4) = 0

END SUB

SUB DoSound (A AS INTEGER, B AS INTEGER) STATIC

IF Snd AND Dead = 0 THEN PLAY Sounds(A, B)

END SUB

SUB EndOfGame

DIM HiNames(1 TO 10) AS STRING * 16
DIM HiScores(1 TO 10) AS STRING * 8

CLS
InitStars
'IF Ex1 = 10 THEN g$ = "CONGRATULATIONS" ELSE g$ = "   GAME OVER   "
IF Ex1 <> 10 THEN
   Text 1, 100, 20, 0, 0, "   GAME OVER   ", 1
ELSE
   Text 0, 80, 50, 0, 0, "LIVES REMAINING:", 2
   Text 2, 220, 50, 0, 0, STR$(Lives), 5
   Text 0, 80, 70, 0, 0, "BONUS:", 2
   Text 2, 220, 70, 0, 0, STR$(Lives * 5000&), 5
   Score = Score + CLNG(1& * Lives * 5000&)
END IF
'Text 0, 160, 160, 0, 0, "press any key to continue . . .", 5

   C = 0: t2 = 0
   DO
      C = C + 1
      OP = PEEK(284): DEF SEG
     
      IF INKEY$ <> "" THEN t2 = 1
     
      StarPalLoop C, 1
   LOOP UNTIL t2 = 1
  
   CLS

END SUB

SUB EnMotion (t AS INTEGER, Ch AS INTEGER, xmax AS INTEGER, ymax AS INTEGER)
   IF 100 * RND > Ch THEN
      Enemies(t).DX = Enemies(t).DX + INT(RND * 3 - 1)
      Enemies(t).DY = Enemies(t).DY + INT(RND * 3 - 1)
   END IF
   IF ABS(Enemies(t).DX) > xmax THEN Enemies(t).DX = Enemies(t).DX - SGN(Enemies(t).DX)
   IF ABS(Enemies(t).DY) > ymax THEN Enemies(t).DY = Enemies(t).DY - SGN(Enemies(t).DY)

END SUB

FUNCTION EnShoot (n AS INTEGER) STATIC

IF (10000 * RND <= EnData(2, n) * ShootChance) THEN EnShoot = 1 ELSE EnShoot = 0

END FUNCTION

SUB Explode (x1 AS INTEGER, y1 AS INTEGER, DX1 AS INTEGER, DY1 AS INTEGER, s AS INTEGER, Linked AS INTEGER) STATIC

   t2 = NextFreeObj(Enemies(), MaxEn, MaxObj)
   IF t2 THEN
      IF s = 1 THEN Enemies(t2).p = -11 ELSE Enemies(t2).p = -1
      Enemies(t2).DX = DX1: Enemies(t2).DY = DY1
      Enemies(t2).X = x1: Enemies(t2).Y = y1
      Enemies(t2).g = Linked
   END IF

END SUB

SUB FireShot STATIC

IF ShotCount < 0 THEN ShotCount = ShotCount + 1
IF K(1) = 0 THEN ShotOK = 1
IF ShotOK = 1 AND (K(1) = 1 OR SB > 0) AND Dead = 0 THEN
   IF ShotCount >= 0 THEN
      DoSound 1, CurrWeap
      SB = 0
      ShotCount = -Weap(CurrWeap).ShotDelay
      ShotOK = Weap(CurrWeap).Automatic
      t = NextFreeObj(Shots1(), 0, MaxShots)
      IF t THEN
         Shots1(t).p = Weap(CurrWeap).Shotp
         Shots1(t).Damage = Weap(CurrWeap).Damage
         Shots1(t).X = Ship.X
         Shots1(t).Y = Ship.Y - 10
         IF Shots1(t).p > 0 THEN
            Shots1(t).XSize = 10: Shots1(t).YSize = 10
         ELSEIF Shots1(t).p < 0 THEN
            Shots1(t).XSize = 5: Shots1(t).YSize = 42
         END IF
         ShotsFired = ShotsFired + 1
         SELECT CASE CurrWeap
            CASE 1
               Shots1(t).DX = Ship.DX
               Shots1(t).DY = -3
            CASE 2, 3
               ShotsFired = ShotsFired + 1
               Shots1(t).X = Ship.X - 6
               Shots1(t).Y = Ship.Y
               Shots1(t).DX = Ship.DX
               Shots1(t).DY = -3
               t = NextFreeObj(Shots1(), t, MaxShots)
               IF t THEN
                  Shots1(t).p = Weap(CurrWeap).Shotp
                  Shots1(t).X = Ship.X + 6
                  Shots1(t).Y = Ship.Y
                  Shots1(t).DX = Ship.DX
                  Shots1(t).DY = -3
                  Shots1(t).XSize = 10: Shots1(t).YSize = 10
               END IF
            CASE 4
               IF RND > .8 THEN
                  Shots1(t).DX = SGN(Ship.DX)
               ELSE
                  Shots1(t).DX = INT(RND * 15 - 7) + SGN(Ship.DX)
               END IF
               Shots1(t).DY = -8
            CASE 5
               Shots1(t).DX = INT(RND * 5 - 2) + SGN(Ship.DX)
               Shots1(t).DY = -9
            CASE 6
               Shots1(t).DX = INT(RND * 3 - 1) + Ship.DX \ 2
               Shots1(t).DY = -9
            CASE 7, 8, 9
               Shots1(t).Y = Ship.Y + 15
               Shots1(t).DX = SGN(Ship.DX)
               Shots1(t).DY = -42
         END SELECT
         IF CurrWeap > 1 THEN
            Weap(CurrWeap).Avail = Weap(CurrWeap).Avail - 1
            IF Weap(CurrWeap).Avail = 0 THEN
               LINE (124, 192)-(200, 199), 0, BF
               DO UNTIL Weap(CurrWeap).Avail
                  CurrWeap = (CurrWeap + 7) MOD 9 + 1
               LOOP
            END IF
         END IF
      END IF
   ELSE
      SB = 1
   END IF
END IF

END SUB

SUB GetPics

' load palette
DEF SEG = VARSEG(Pal(0)): BLOAD "game.pal", VARPTR(Pal(0))
SetPalette Pal(), 0, 255: PALETTE 255, 0

' load images
DEF SEG = VARSEG(FontPics(0)): BLOAD "font.qbs", VARPTR(FontPics(0))
DEF SEG = VARSEG(ShipPics(0)): BLOAD "ship.qbs", VARPTR(ShipPics(0))
DEF SEG = VARSEG(ShotPics(0)): BLOAD "shots.qbs", VARPTR(ShotPics(0))
DEF SEG = VARSEG(EnShotPics(0)): BLOAD "enshots.qbs", VARPTR(EnShotPics(0))
DEF SEG = VARSEG(EnPics(0)): BLOAD "enemies.qbs", VARPTR(EnPics(0))
DEF SEG = VARSEG(EnDams(0)): BLOAD "enemies.dam", VARPTR(EnDams(0))
DEF SEG = VARSEG(MBPics(0)): BLOAD "miniboss.qbs", VARPTR(MBPics(0))
DEF SEG = VARSEG(MBDams(0)): BLOAD "miniboss.dam", VARPTR(MBDams(0))
DEF SEG = VARSEG(LExplodePics(0)): BLOAD "explode.qbs", VARPTR(LExplodePics(0))
DEF SEG = VARSEG(LExplodeMasks(0)): BLOAD "explode.mas", VARPTR(LExplodeMasks(0))
DEF SEG = VARSEG(BExplodePics(0)): BLOAD "explode2.qbs", VARPTR(BExplodePics(0))
DEF SEG = VARSEG(BExplodeMasks(0)): BLOAD "explode2.mas", VARPTR(BExplodeMasks(0))
DEF SEG = VARSEG(LasPics(0)): BLOAD "lasers.qbs", VARPTR(LasPics(0))
DEF SEG = VARSEG(ZapPics(0)): BLOAD "zap.qbs", VARPTR(ZapPics(0))
DEF SEG = VARSEG(GoodiesPics(0)): BLOAD "goodies.qbs", VARPTR(GoodiesPics(0))
DEF SEG = VARSEG(B5FPics(0)): BLOAD "b5fp.qbs", VARPTR(B5FPics(0))
DEF SEG

FOR t = 1 TO 2
   FOR l = 0 TO 95
      FontPics(t * 3264 + l * 34) = FontPics(l * 34)
      FontPics(t * 3264 + l * 34 + 1) = FontPics(l * 34 + 1)
      FOR B = 2 TO 33
         t2 = FontPics(l * 34 + B)
         b1 = t2 AND 255
         b2 = (t2 - b1) \ 256
         IF b1 >= 1 AND b1 <= 4 THEN t2 = t2 + t * 4
         IF b2 >= 1 AND b2 <= 4 THEN t2 = t2 + t * 1024
         FontPics(t * 3264 + l * 34 + B) = t2
      NEXT B
   NEXT l
NEXT t

END SUB

SUB HelpScreen STATIC

scr = 1
x1 = 96: y1 = 76: y2 = 18
xc = 160: yc = 86
REDIM Temp(((2 * x1 + 1) * (2 * y1 + 1) + 4) \ 2) AS INTEGER
GET (xc - x1, yc - y1)-(xc + x1, yc + y1), Temp(0)

FOR t = -3 TO 3
   LINE (xc + 3 - x1 + t, yc + 3 - y1 + t)-(xc - 3 + x1 - t, yc - 3 + y1 - t), 112 + ABS(t) * 3 + 5, B
NEXT t


DO

   LINE (xc + 7 - x1, yc + 7 - y1)-(xc - 7 + x1, yc - 7 + y1), 0, BF
   FOR t = -3 TO 3
      LINE (xc + 3 - x1 + ABS(t), y2 + 15 + t)-(xc - 3 + x1 - ABS(t), y2 + 15 + t), 112 + ABS(t) * 3 + 5
      LINE (xc + 3 - x1 + ABS(t), y2 + 118 + t)-(xc - 3 + x1 - ABS(t), y2 + 118 + t), 112 + ABS(t) * 3 + 5
   NEXT t
   FOR t = -3 TO 3
      LINE (207 + t, y2 + 118 + ABS(t))-(207 + t, yc - 3 + y1 - ABS(t)), 112 + ABS(t) * 3 + 5
   NEXT t


   SELECT CASE scr
      CASE 1
          FOR t = 1 TO 23
             Text TextDat(t, 1), TextDat(t, 2), y2 + TextDat(t, 3), 0, 0, TextStr(t), TextDat(t, 4)
          NEXT t
      CASE ELSE
          FOR t = 24 TO 35
             Text TextDat(t, 1), TextDat(t, 2), y2 + TextDat(t, 3), 0, 0, TextStr(t), TextDat(t, 4)
          NEXT t
         t2 = y2 + 9
         FOR t = 0 TO 6
            t2 = t2 + 13: IF t2 = y2 + 74 THEN t2 = t2 + 2
            PUT (95, t2), GoodiesPics(t * 52), PSET
         NEXT t
   END SELECT


   DO
      OP = PEEK(284): DEF SEG
      C& = C& + 1
      SELECT CASE UCASE$(INKEY$)
         CASE CHR$(27)
            Ex1 = 1
         CASE IS <> ""
            Ex1 = 2: scr = 1 - scr
      END SELECT
      StarPalLoop CINT(C&), 0
   LOOP UNTIL Ex1

   IF Ex1 = 1 THEN
      Ex1 = 0
      PUT (xc - x1, yc - y1), Temp(0), PSET
      EXIT SUB
   END IF
   Ex1 = 0

LOOP


END SUB

SUB HitEnemy (Enn AS INTEGER, Shn AS INTEGER, s AS INTEGER) STATIC

   IF Enemies(Enn).Damage = 0 THEN
      EXIT SUB
   ELSEIF Enemies(Enn).Damage < 0 THEN
      Enemies(Enn).Damage = -Enemies(Enn).Damage
   END IF
   ShotsHit = ShotsHit + 1
   Enemies(Enn).Damage = Enemies(Enn).Damage - Shots1(Shn).Damage
   IF Enemies(Enn).Damage <= 0 THEN
      IF s THEN DoSound 4, 5
      Enemies(Enn).Damage = 0
      IF Enemies(Enn).p <= 10 THEN Score = Score + ScoreData(Enemies(Enn).p)
   ELSE
      IF s THEN DoSound 4, 3
      Enemies(Enn).Damage = -Enemies(Enn).Damage
   END IF
   IF Enemies(Enn).p > 10 THEN Explode Shots1(Shn).X, Shots1(Shn).Y, 0, 0, 0, Enn
  
END SUB

SUB Init

RANDOMIZE TIMER
SCREEN 13, 0, 0, 0: CLS

GetPics

FontPC(0) = 1: FontPC(1) = 1: FontPC(2) = 1

OPEN "starfire.dat" FOR INPUT AS #1

FOR t = 0 TO 95: INPUT #1, FontWidth(t): NEXT t
FOR t = 1 TO 6: FOR t2 = 1 TO 4
   INPUT #1, FontPal(t, t2)
NEXT t2, t
FOR t = 7 TO 11: FOR t2 = 1 TO 4
   FontPal(t, t2) = FontPal(12 - t, 5 - t2)
NEXT t2, t
FOR t = 12 TO 20: FOR t2 = 1 TO 4
   FontPal(t, t2) = FontPal(22 - t, t2)
NEXT t2, t

FOR t = -5 TO 20: INPUT #1, ScoreData(t): NEXT t

FOR t = 1 TO 9
   INPUT #1, Weap(t).Shipp, Weap(t).Shotp, Weap(t).ShotDelay
   INPUT #1, Weap(t).Automatic, Weap(t).Damage, Weap(t).MaxAmmo
NEXT t
FOR t = 0 TO 15
   INPUT #1, t2, t3, t4
   FOR t1 = 1 TO 3
      ShieldPal(t1, t).Red = CINT(t2 * (4 - t1) / 3)
      ShieldPal(t1, t).Green = CINT(t3 * (4 - t1) / 3)
      ShieldPal(t1, t).Blue = CINT(t4 * (4 - t1) / 3)
      'ShieldPal(t1, t) = CINT(t2 * (4 - t1) / 3) + CINT(t3 * (4 - t1) / 3) * 256 + CINT(t4 * (4 - t1) / 3) * 65536
   NEXT t1
NEXT t
FOR t = 0 TO 10
   INPUT #1, t2, t3, t4
   LasPal(t) = t2 + t3 * 256 + t4 * 65536
NEXT t
FOR t = 1 TO 20: INPUT #1, EnData(1, t): NEXT t
FOR t = 1 TO 20: INPUT #1, EnData(2, t): NEXT t
FOR t = 1 TO 20: INPUT #1, EnData(3, t): NEXT t
FOR t = 1 TO 5: INPUT #1, BossData(t): NEXT t
FOR t = -1 TO 4: INPUT #1, EnShotData(t): NEXT t
FOR t = 1 TO 5: FOR t2 = 1 TO 3: INPUT #1, BossMoves(t, t2): NEXT t2, t
FOR t = 1 TO 4: FOR t2 = 1 TO 3: INPUT #1, MBMoves(t, t2): NEXT t2, t

Snd = 1: PLAY "MB ML T255 L64"
FOR t = 1 TO 4
   FOR t2 = 1 TO 10: INPUT #1, Sounds(t, t2): NEXT t2
NEXT t

FOR t = 1 TO 45
   INPUT #1, TextDat(t, 1), TextDat(t, 2), TextDat(t, 3)
   INPUT #1, TextStr(t), TextDat(t, 4)
NEXT t

CLOSE #1

NumStars = 25
Level = 0: Score = 0
Ship.p = 1
Ship.XSize = 20: Ship.YSize = 20
CurrWeap = 1: Weap(1).Avail = Weap(1).MaxAmmo
Lives = 5: Shields = 2: Bombs = 1: Speed = 6
ShootChance = 50: GoodieChance = 10
MaxEn = 5

FOR t = 1 TO MaxObj: Enemies(t).XSize = 20: Enemies(t).YSize = 20: NEXT t
FOR t = 1 TO MaxShots: Shots1(t).XSize = 10: Shots1(t).YSize = 10: NEXT t
FOR t = 1 TO MaxEnShots: Shots2(t).XSize = 10: Shots2(t).YSize = 10: NEXT t

IF GameMode = 0 THEN
   NewLevel
ELSE
   Ship.X = 160: Ship.Y = 180: Ship.DX = 0: Ship.DY = 0
   Lives = Lives + 1: Dead = 50
   ShotsFired = 0: ShotsHit = 0
   FontPC(0) = 0: FontPC(1) = 0: FontPC(2) = 0
   RotateFontPal 0: RotateFontPal 1: RotateFontPal 2
END IF

END SUB

SUB InitStars

FOR t = 1 TO NumStars
   NewStar t
   Stars(t).Y = INT(RND * 200)
NEXT t

END SUB

SUB InterpretLev STATIC

SELECT CASE LevelData(LevCounter)
   CASE 0
   CASE 1
      CounterDat = -NextByte
      IF CounterDat = 0 THEN
         CounterDat = 1
      ELSEIF NumEn <= -CounterDat THEN
         CounterDat = 0
      END IF
   CASE 2
      CounterDat = 2
      Counter = NextByte
   CASE 3
      SaveLevel = LevCounter
   CASE 4
      CounterDat = 4
      Counter = NextByte + 256 * NextByte
   CASE 7
      GoodieChance = NextByte
   CASE 8
      ShootChance = NextByte
   CASE 9
      MaxEn = NextByte
   CASE 10
      NewEnemy 2 * NextByte, NextByte, NextByte, NextByte
   CASE 11
      NewEnemy 2 * NextByte, NextByte, 10 + NextByte, NextByte
   CASE 12
      CounterDat = 12: Counter = 32767: NewBoss
    CASE 13
      NewGoodie 2 * NextByte, NextByte, NextByte
   CASE 14

   CASE 15
      LastGoodie = NextByte
   CASE 16
   CASE 17
   CASE 18
   CASE 19
   CASE 20
   CASE 255
      CounterDat = 255
      Counter = 50
  
'   CASE 5, 6
END SELECT

LevCounter = LevCounter + 1

END SUB

SUB MoveBoss STATIC

ShiftBoss
od = Boss.Damage
Boss.Damage = ABS(Boss.Damage)

SELECT CASE Level
   CASE 1

      FOR t = 1 TO MaxShots
         IF ValidShot(t) AND ABS(Shots1(t).Y - Boss.Y) <= 22 THEN
            IF ABS(Boss.X - Shots1(t).X) <= 32 THEN
               DoSound 4, 3
               ShotsHit = ShotsHit + 1
               SELECT CASE Boss.X - Shots1(t).X
                  CASE -32 TO -20
                     IF BossExtra(1) MOD 2 = 0 THEN
                        BossExtra(2) = BossExtra(2) + Shots1(t).Damage
                        Boss.Damage = Boss.Damage + Shots1(t).Damage
                        IF BossExtra(2) >= 25 THEN
                           DoSound 4, 4
                           BossExtra(1) = BossExtra(1) + 1
                           Boss.Damage = Boss.Damage - 1
                           Explode Boss.X + 30, Boss.Y - 11, Boss.DX, Boss.DY, 1, -1
                           Explode Boss.X + 30, Boss.Y + 11, Boss.DX, Boss.DY, 1, -1
                        END IF
                     END IF
                  CASE 20 TO 32
                     IF BossExtra(1) < 2 THEN
                        BossExtra(3) = BossExtra(3) + Shots1(t).Damage
                        Boss.Damage = Boss.Damage + Shots1(t).Damage
                        IF BossExtra(3) >= 25 THEN
                           DoSound 4, 4
                           BossExtra(1) = BossExtra(1) + 2
                           Boss.Damage = Boss.Damage - 1
                           Explode Boss.X - 30, Boss.Y - 11, Boss.DX, Boss.DY, 1, -1
                           Explode Boss.X - 30, Boss.Y + 11, Boss.DX, Boss.DY, 1, -1
                        END IF
                     END IF
               END SELECT
               Boss.Damage = Boss.Damage - Shots1(t).Damage
               IF Shots1(t).p < 0 THEN t2 = 3: t3 = 21 ELSE t2 = 5: t3 = 5
               Shots1(t).p = 0
               Blank Shots1(t).X, Shots1(t).Y, t2, t3
               Explode Shots1(t).X, Shots1(t).Y, 0, 0, 0, -1
            END IF
         END IF
      NEXT t
      IF Boss.Damage < od THEN Boss.Damage = -Boss.Damage

      IF RND > .9 AND Boss.Y >= 25 AND ABS(Boss.Damage) >= 20 THEN
         SELECT CASE INT(RND * 5)
            CASE 0 ' shell
               DoSound 2, 3
               NewEnShot 6, 3, Boss.X, Boss.Y + 15, Boss.DX, Boss.DY + 5
            CASE 1, 2 ' missile
               DoSound 2, 2
               NewEnShot 3, 1, Boss.X - 9 + 18 * INT(RND * 2), Boss.Y + 22, Boss.DX, Boss.DY + 3
            CASE ELSE  ' shots
               DoSound 2, 4
               t3 = INT(RND * 2) * 2 - 1
               NewEnShot 1, 1, Boss.X + 14 * t3, Boss.Y + 21, Boss.DX + t3, SGN(Boss.DY) + 8
               NewEnShot 1, 1, Boss.X + 14 * t3 - 4 * t3, Boss.Y + 21, Boss.DX - t3, SGN(Boss.DY) + 8
         END SELECT
      END IF
   CASE 2
      FOR t = 1 TO MaxShots
         t3 = 0
         IF ValidShot(t) AND ABS(Boss.X - Shots1(t).X) <= 32 THEN
            IF ABS(Shots1(t).Y - Boss.Y) <= 24 THEN
               t2 = Boss.X - Shots1(t).X
               IF t2 >= -32 AND t2 <= -12 AND BossExtra(1) MOD 2 = 0 THEN
                  DoSound 4, 3
                  ShotsHit = ShotsHit + 1
                  t3 = 1
                  BossExtra(2) = BossExtra(2) + Shots1(t).Damage
                  Boss.Damage = Boss.Damage + Shots1(t).Damage - 1
                  IF BossExtra(2) >= 35 THEN
                     DoSound 4, 4
                     BossExtra(1) = BossExtra(1) + 1
                     Explode Boss.X + 15, Boss.Y + 23, Boss.DX, Boss.DY, 1, -1
                     Explode Boss.X + 21, Boss.Y + 7, Boss.DX, Boss.DY, 1, -1
                  END IF
               ELSEIF t2 >= 12 AND t2 <= 32 AND BossExtra(1) < 2 THEN
                  DoSound 4, 3
                  ShotsHit = ShotsHit + 1
                  t3 = 1
                  BossExtra(3) = BossExtra(3) + Shots1(t).Damage
                  Boss.Damage = Boss.Damage + Shots1(t).Damage - 1
                  IF BossExtra(3) >= 35 THEN
                     DoSound 4, 4
                     BossExtra(1) = BossExtra(1) + 2
                     Explode Boss.X - 15, Boss.Y + 23, Boss.DX, Boss.DY, 1, -1
                     Explode Boss.X - 21, Boss.Y + 7, Boss.DX, Boss.DY, 1, -1
                  END IF
               ELSEIF ABS(Shots1(t).Y - Boss.Y) <= 18 THEN
                  DoSound 4, 3
                  ShotsHit = ShotsHit + 1
                  t3 = 1
               END IF
            END IF
         END IF
         IF t3 THEN
            Boss.Damage = Boss.Damage - Shots1(t).Damage
            IF Shots1(t).p < 0 THEN t2 = 3: t3 = 21 ELSE t2 = 5: t3 = 5
            Shots1(t).p = 0
            Blank Shots1(t).X, Shots1(t).Y, t2, t3
            Explode Shots1(t).X, Shots1(t).Y, 0, 0, 0, -1
         END IF
      NEXT t
      IF Boss.Damage < od THEN Boss.Damage = -Boss.Damage

      IF RND > .92 AND ABS(Boss.Damage) >= 20 AND BossExtra(4) = 0 THEN
         BossExtra(4) = INT(RND * 2 + 1) ' 1 = missiles, 2 = shots
         BossExtra(5) = 0
         IF BossExtra(4) = 2 THEN
            BossExtra(7) = 1 - 2 * imt(RND * 2)
            BossExtra(6) = INT(RND * 7 - 3)
            BossExtra(9) = INT(RND * 25 + 5)
         ELSE
            BossExtra(9) = 0
         END IF
      END IF
      IF BossExtra(4) AND Boss.Y >= 25 THEN
         BossExtra(5) = BossExtra(5) + 1
         SELECT CASE BossExtra(4)
            CASE 1
               IF BossExtra(5) MOD 4 = 0 AND BossExtra(1) < 3 THEN
                  DoSound 2, 6
                  FOR t3 = -1 TO 1 STEP 2
                     IF BossExtra(1) > 1 AND t3 = -1 THEN t3 = 1
                     IF BossExtra(1) MOD 2 = 1 AND t3 = 1 THEN BossExtra(4) = 0: EXIT FOR
                     NewEnShot 3, 1, Boss.X + (14 + BossExtra(5)) * t3, Boss.Y + 30 - BossExtra(5), Boss.DX, Boss.DY + 3
                  NEXT t3
                  IF BossExtra(5) = 12 THEN BossExtra(4) = 0
               END IF
            CASE 2
               BossExtra(9) = BossExtra(9) - 1
               IF BossExtra(5) MOD 2 THEN
                  BossExtra(6) = BossExtra(6) + BossExtra(7)
                  IF BossExtra(6) <= -3 THEN
                     BossExtra(7) = 1
                  ELSEIF BossExtra(6) >= 3 THEN
                     BossExtra(7) = -1
                  END IF
                  DoSound 2, 1
                  NewEnShot 1, 1, Boss.X + BossExtra(6) * 2, Boss.Y + 16 - ABS(BossExtra(6)), Boss.DX + BossExtra(6), 8 + SGN(Boss.DY)
                  IF BossExtra(9) <= 0 THEN BossExtra(4) = 0
               END IF
         END SELECT
      END IF
   CASE 3
      FOR t = 1 TO MaxShots
         t3 = 0
         IF ValidShot(t) AND ABS(Boss.X - Shots1(t).X) <= 34 THEN
            IF ABS(Shots1(t).Y - Boss.Y) <= 24 THEN
               t2 = Boss.X - Shots1(t).X
               IF ABS(t2) <= 9 AND BossExtra(1) = 0 THEN
                  DoSound 4, 3
                  ShotsHit = ShotsHit + 1
                  t3 = 1
                  BossExtra(2) = BossExtra(2) + Shots1(t).Damage
                  Boss.Damage = Boss.Damage + Shots1(t).Damage - 1
                  IF BossExtra(2) >= 40 THEN
                     DoSound 4, 4
                     BossExtra(1) = BossExtra(1) + 1
                     Explode Boss.X, Boss.Y + 16, Boss.DX, Boss.DY, 1, -1
                  END IF
               ELSEIF ABS(t2) <= 9 AND Shots1(t).Y - Boss.Y <= 15 THEN
                  DoSound 4, 3
                  ShotsHit = ShotsHit + 1
                  t3 = 1
               ELSEIF ABS(t2) > 9 THEN
                  DoSound 4, 3
                  ShotsHit = ShotsHit + 1
                  t3 = 1
               END IF
            END IF
         END IF
         IF t3 THEN
            Boss.Damage = Boss.Damage - Shots1(t).Damage
            IF Shots1(t).p < 0 THEN t2 = 3: t3 = 21 ELSE t2 = 5: t3 = 5
            Shots1(t).p = 0
            Blank Shots1(t).X, Shots1(t).Y, t2, t3
            Explode Shots1(t).X, Shots1(t).Y, 0, 0, 0, -1
         END IF
      NEXT t
      IF Boss.Damage < od THEN Boss.Damage = -Boss.Damage
      IF RND > .8 AND ABS(Boss.Damage) >= 20 AND Boss.Y >= 25 THEN
         DoSound 2, 1
         SELECT CASE INT(RND * 3)
            CASE 0
               x1 = 13: y1 = 22
               t2 = -5: t3 = 4
            CASE 1
               x1 = 23: y1 = 22
               t2 = -2: t3 = 6
            CASE 2
               x1 = 35: y1 = 2
               t2 = 1: t3 = 6
         END SELECT
         t = INT(RND * 2) * 2 - 1
         NewEnShot 1, 1, Boss.X + x1 * t, Boss.Y + y1, Boss.DX + t2 * t, Boss.DY + t3
      END IF
      IF RND > .95 AND ABS(Boss.Damage) >= 20 AND BossExtra(4) = 0 THEN
         BossExtra(4) = INT(RND * 20 + 5)
      END IF
      IF BossExtra(5) THEN ' old zap to delete
         LINE (BossExtra(6), BossExtra(7))-(BossExtra(6) + 10, 199), 0, BF
         BossExtra(5) = 0: PALETTE 0, 0
      END IF
      IF BossExtra(4) AND Boss.Y >= 25 AND Dead < 35 THEN
         BossExtra(4) = BossExtra(4) - 1
         IF BossExtra(1) = 0 THEN
            'DoSound 2, 9
            BossExtra(5) = 1
            BossExtra(6) = Boss.X - 5: BossExtra(7) = Boss.Y + 25
            VPutINT BossExtra(6), BossExtra(7) - INT(RND * 150), ZapPics(), 0, 1, Boss.Y + 25, 199
            IF RND > 0 THEN PALETTE 0, INT(RND * 63) * 65793
            IF ABS(Boss.X - Ship.X) <= 9 AND Dead = 0 THEN
               NoHits = 0
               IF Shields > 0 THEN
                  DoSound 4, 1
                  Shields = Shields - 1
                  IF Shields < 0 THEN Shields = 0
                  ShPal
               ELSE
                  DoSound 4, 2
                  Dead = 1
                  Explode Ship.X, Ship.Y, Ship.DX, Ship.DY, 1, 0
               END IF
            END IF
         END IF
      END IF
   CASE 4
      FOR t = 1 TO MaxShots
         IF ValidShot(t) AND ABS(Shots1(t).Y - Boss.Y) <= 23 THEN
            IF ABS(Boss.X - Shots1(t).X) <= 34 THEN
               DoSound 4, 3
               ShotsHit = ShotsHit + 1
               SELECT CASE Boss.X - Shots1(t).X
                  CASE -34 TO -24
                     IF BossExtra(1) MOD 2 = 0 THEN
                        BossExtra(2) = BossExtra(2) + Shots1(t).Damage
                        Boss.Damage = Boss.Damage + Shots1(t).Damage - 1
                        IF BossExtra(2) >= 32 THEN
                           DoSound 4, 4
                           BossExtra(1) = BossExtra(1) + 1
                           Explode Boss.X + 30, Boss.Y - 12, Boss.DX, Boss.DY, 1, -1
                           Explode Boss.X + 30, Boss.Y + 12, Boss.DX, Boss.DY, 1, -1
                        END IF
                     END IF
                  CASE 24 TO 34
                     IF BossExtra(1) < 2 THEN
                        BossExtra(3) = BossExtra(3) + Shots1(t).Damage
                        Boss.Damage = Boss.Damage + Shots1(t).Damage - 1
                        IF BossExtra(3) >= 32 THEN
                           DoSound 4, 4
                           BossExtra(1) = BossExtra(1) + 2
                           Explode Boss.X - 30, Boss.Y - 12, Boss.DX, Boss.DY, 1, -1
                           Explode Boss.X - 30, Boss.Y + 12, Boss.DX, Boss.DY, 1, -1
                        END IF
                     END IF
               END SELECT
               Boss.Damage = Boss.Damage - Shots1(t).Damage
               IF Shots1(t).p < 0 THEN t2 = 3: t3 = 21 ELSE t2 = 5: t3 = 5
               Shots1(t).p = 0
               Blank Shots1(t).X, Shots1(t).Y, t2, t3
               Explode Shots1(t).X, Shots1(t).Y, 0, 0, 0, -1
            END IF
         END IF
      NEXT t
      IF Boss.Damage < od THEN Boss.Damage = -Boss.Damage

      IF RND > .85 AND Boss.Y >= 25 AND ABS(Boss.Damage) >= 20 THEN
         SELECT CASE INT(RND * 5)
            CASE 0 ' shell
               DoSound 2, 3
               XX = (Ship.X - Boss.X): YY = (Ship.Y - Boss.Y)
               t3 = (11 * XX) \ YY: IF ABS(t3) > 7 THEN t3 = Boss.DX
               NewEnShot 6, 3, Boss.X, Boss.Y + 20, t3, Boss.DY + 5
            CASE 1, 2 ' missiles
               IF BossExtra(5) = 0 THEN BossExtra(5) = 5
            CASE ELSE  ' lasers
               IF BossExtra(6) = 0 THEN BossExtra(6) = 1
               DoSound 2, 8
         END SELECT
      END IF
      IF BossExtra(6) THEN
         BossExtra(6) = BossExtra(6) + 1
         PALETTE 254, LasPal(BossExtra(6))
         IF BossExtra(6) = 10 THEN
            BossExtra(6) = 0
            DoSound 2, 8
            t3 = Boss.Y MOD 42: t3 = Boss.Y - (10 - t3) * (t3 > 10)
            IF BossExtra(1) < 2 THEN NewEnShot -4, 3, Boss.X - 31, t3, SGN(Boss.DX), 42
            IF BossExtra(1) MOD 2 = 0 THEN NewEnShot -4, 3, Boss.X + 31, t3, SGN(Boss.DX), 42
         END IF
      END IF
      IF BossExtra(5) THEN
         BossExtra(5) = BossExtra(5) - 1
         IF BossExtra(5) MOD 4 = 0 THEN
            DoSound 2, 6
            NewEnShot 3, 1, Boss.X - 22 + 2 * BossExtra(5), Boss.Y + 22 + BossExtra(5), Boss.DX, Boss.DY + 1
            NewEnShot 3, 1, Boss.X + 22 - 2 * BossExtra(5), Boss.Y + 22 + BossExtra(5), Boss.DX, Boss.DY + 1
         END IF
      END IF
   CASE 5
      FOR t = 1 TO MaxShots
         t3 = 0
         IF ValidShot(t) AND ABS(Boss.X - Shots1(t).X) <= 33 THEN
            IF ABS(Shots1(t).Y - Boss.Y) <= 23 THEN
               t2 = Boss.X - Shots1(t).X
               IF ABS(t2) <= 8 AND BossExtra(9) = 1 THEN
                  DoSound 4, 3
                  ShotsHit = ShotsHit + 1
                  t3 = 1
                  BossExtra(10) = BossExtra(10) + Shots1(t).Damage
                  Boss.Damage = Boss.Damage + Shots1(t).Damage - 1
                  IF BossExtra(10) >= 50 THEN
                     DoSound 4, 4
                     BossExtra(9) = 0
                     Explode Boss.X, Boss.Y + 16, Boss.DX, Boss.DY, 1, -1
                  END IF
               ELSEIF ABS(t2) <= 8 AND Shots1(t).Y - Boss.Y <= 15 THEN
                  DoSound 4, 3
                  ShotsHit = ShotsHit + 1
                  t3 = 1
               ELSEIF t2 >= -32 AND t2 <= -16 AND BossExtra(1) MOD 2 = 0 THEN
                  DoSound 4, 3
                  ShotsHit = ShotsHit + 1
                  t3 = 1
                  BossExtra(2) = BossExtra(2) + Shots1(t).Damage
                  Boss.Damage = Boss.Damage + Shots1(t).Damage - 1
                  IF BossExtra(2) >= 40 THEN
                     DoSound 4, 4
                     BossExtra(1) = BossExtra(1) + 1
                     Explode Boss.X + 24, Boss.Y + -12, Boss.DX, Boss.DY, 1, -1
                     Explode Boss.X + 24, Boss.Y + 12, Boss.DX, Boss.DY, 1, -1
                  END IF
               ELSEIF t2 >= 16 AND t2 <= 32 AND BossExtra(1) < 2 THEN
                  DoSound 4, 3
                  ShotsHit = ShotsHit + 1
                  t3 = 1
                  BossExtra(3) = BossExtra(3) + Shots1(t).Damage
                  Boss.Damage = Boss.Damage + Shots1(t).Damage - 1
                  IF BossExtra(3) >= 40 THEN
                     DoSound 4, 4
                     BossExtra(1) = BossExtra(1) + 2
                     Explode Boss.X - 24, Boss.Y - 12, Boss.DX, Boss.DY, 1, -1
                     Explode Boss.X - 24, Boss.Y + 12, Boss.DX, Boss.DY, 1, -1
                  END IF
               ELSEIF ABS(Shots1(t).Y - Boss.Y) <= 18 THEN
                  DoSound 4, 3
                  ShotsHit = ShotsHit + 1
                  t3 = 1
               END IF
            END IF
         END IF
         IF t3 THEN
            Boss.Damage = Boss.Damage - Shots1(t).Damage
            IF Shots1(t).p < 0 THEN t2 = 3: t3 = 21 ELSE t2 = 5: t3 = 5
            Shots1(t).p = 0
            Blank Shots1(t).X, Shots1(t).Y, t2, t3
            Explode Shots1(t).X, Shots1(t).Y, 0, 0, 0, -1
         END IF
      NEXT t
      IF Boss.Damage < od THEN Boss.Damage = -Boss.Damage
      IF RND > .8 AND ABS(Boss.Damage) >= 20 AND Boss.Y >= 25 THEN
         IF RND > .5 THEN ' shells
            XX = (Ship.X - Boss.X): YY = (Ship.Y - Boss.Y)
            t3 = (11 * XX) \ YY: IF ABS(t3) > 8 THEN t3 = CINT(8 * SGN(t3) * RND)
            IF BossExtra(1) < 4 THEN DoSound 2, 3
            IF BossExtra(1) < 2 THEN NewEnShot 6, 3, Boss.X - 25, Boss.Y + 22, t3, Boss.DY + 5
            IF BossExtra(1) MOD 2 = 0 THEN NewEnShot 6, 3, Boss.X + 26, Boss.Y + 22, t3, Boss.DY + 5
         ELSE  ' missiles
            IF BossExtra(8) = 0 THEN BossExtra(8) = 4
         END IF
      END IF
      IF RND > .95 AND ABS(Boss.Damage) >= 20 AND BossExtra(4) = 0 THEN
         BossExtra(4) = INT(RND * 16 + 10)
      END IF
      IF BossExtra(8) THEN
         BossExtra(8) = BossExtra(8) - 1
         IF BossExtra(8) MOD 3 = 0 THEN
            DoSound 2, 6
            NewEnShot 3, 1, Boss.X - 17 + 2 * BossExtra(8), Boss.Y + 15, Boss.DX, Boss.DY + 2
            NewEnShot 3, 1, Boss.X + 17 - 2 * BossExtra(8), Boss.Y + 15, Boss.DX, Boss.DY + 2
         END IF
      END IF
      IF BossExtra(5) THEN ' old zap to delete
         LINE (BossExtra(6), BossExtra(7))-(BossExtra(6) + 10, 199), 0, BF
         BossExtra(5) = 0: PALETTE 0, 0
      END IF
      IF BossExtra(4) AND Boss.Y >= 25 AND Dead < 35 THEN
         BossExtra(4) = BossExtra(4) - 1
         IF BossExtra(9) = 1 THEN
            'DoSound 2, 9
            BossExtra(5) = 1
            BossExtra(6) = Boss.X - 5: BossExtra(7) = Boss.Y + 25
            VPutINT BossExtra(6), BossExtra(7) - INT(RND * 150), ZapPics(), 0, 1, Boss.Y + 25, 199
            IF RND > 0 THEN PALETTE 0, INT(RND * 63) * 65793
            IF ABS(Boss.X - Ship.X) <= 9 AND Dead = 0 THEN
               NoHits = 0
               IF Shields > 0 THEN
                  DoSound 4, 1
                  Shields = Shields - 2
                  IF Shields < 0 THEN Shields = 0
                  ShPal
               ELSE
                  DoSound 4, 2
                  Dead = 1
                  Explode Ship.X, Ship.Y, Ship.DX, Ship.DY, 1, 0
               END IF
            END IF
         END IF
      END IF

END SELECT




END SUB

SUB MoveEnemies STATIC

   FOR t = 1 TO MaxObj

      SELECT CASE Enemies(t).p
         CASE 0
         CASE -5
            'IF Enemies(t).g = 0 THEN
            Blank Enemies(t).X, Enemies(t).Y, Enemies(t).XSize \ 2, 0
            Enemies(t).p = 0
            IF CounterDat = 10 OR NumEn <= -CounterDat THEN CounterDat = 0

         CASE -17        ' all blown up
            'IF Enemies(t).g = 0 THEN
            Blank Enemies(t).X, Enemies(t).Y, 14, 14
            Enemies(t).p = 0
            IF CounterDat = 10 OR NumEn <= -CounterDat THEN CounterDat = 0
         CASE -4 TO -1, -16 TO -11   ' exploding small or big
            IF Enemies(t).p > -5 THEN t2 = 7 ELSE t2 = 14
            IF Enemies(t).g = 0 THEN Blank Enemies(t).X, Enemies(t).Y, t2, t2
            IF Enemies(t).g > 0 THEN
               Enemies(t).X = Enemies(t).X + Enemies(Enemies(t).g).DX
               Enemies(t).Y = Enemies(t).Y + Enemies(Enemies(t).g).DY
            ELSEIF Enemies(t).g = -1 THEN
               Enemies(t).X = Enemies(t).X + Boss.DX
               Enemies(t).Y = Enemies(t).Y + Boss.DY
            ELSE
               Enemies(t).X = Enemies(t).X + Enemies(t).DX
               Enemies(t).Y = Enemies(t).Y + Enemies(t).DY
            END IF
            IF Enemies(t).p > -5 THEN
               CheckPos t, 7
               PUT (Enemies(t).X - 7, Enemies(t).Y - 7), LExplodeMasks(100 * (-1 - Enemies(t).p)), AND
               PUT (Enemies(t).X - 7, Enemies(t).Y - 7), LExplodePics(100 * (-1 - Enemies(t).p))
            ELSE
               CheckPos t, 14
               PUT (Enemies(t).X - 14, Enemies(t).Y - 14), BExplodeMasks(394 * (-11 - Enemies(t).p)), AND
               PUT (Enemies(t).X - 14, Enemies(t).Y - 14), BExplodePics(394 * (-11 - Enemies(t).p))
            END IF
            Enemies(t).p = Enemies(t).p - 1
         CASE 1
            IF RND > .97 THEN
               Enemies(t).DX = INT(RND * 7) - 3
               Enemies(t).DY = INT(RND * 7) - 3
            END IF
            ShiftEn t
            IF EnShoot(1) THEN
               DoSound 2, 1
               IF RND > .5 THEN t3 = Ship.DX ELSE t3 = Enemies(t).DX
               NewEnShot 1, 1, Enemies(t).X, Enemies(t).Y + 10, t3, Enemies(t).DY + 5
            END IF
         CASE 2
            EnMotion t, 90, 4, 4
            IF Enemies(t).X < 20 THEN Enemies(t).DX = Enemies(t).DX + 1
            IF Enemies(t).X > 299 THEN Enemies(t).DX = Enemies(t).DX - 1
            IF Enemies(t).Y < 20 THEN Enemies(t).DY = Enemies(t).DY + 1
            IF Enemies(t).Y > 90 THEN Enemies(t).DY = Enemies(t).DY - 1
            ShiftEn t
            IF EnShoot(2) THEN
               DoSound 2, 2
               NewEnShot 3, 1, Enemies(t).X, Enemies(t).Y + 6, Enemies(t).DX, Enemies(t).DY + 1
            END IF
         CASE 3
            IF RND > .85 THEN Enemies(t).DY = INT(RND * 7) - 3
            EnMotion t, 85, 5, 4
            IF Enemies(t).Y > 90 THEN Enemies(t).DY = Enemies(t).DY - 1
            ShiftEn t
            IF EnShoot(3) AND Enemies(t).DY >= 0 THEN
               DoSound 2, 3
               XX = (Ship.X - Enemies(t).X): YY = (Ship.Y - Enemies(t).Y)
               t3 = (11 * XX) \ YY: IF ABS(t3) > 7 THEN t3 = Enemies(t).DX
               NewEnShot 6, 3, Enemies(t).X, Enemies(t).Y + 10, t3, Enemies(t).DY + 5
               Enemies(t).DY = Enemies(t).DY - 1
            END IF
         CASE 4
            IF RND > .97 THEN
               Enemies(t).DX = INT(RND * 4 + 2) * (2 * INT(RND * 2) - 1)
               Enemies(t).DY = Enemies(t).DX * (2 * INT(RND * 2) - 1)
            END IF
            ShiftEn t
            IF EnShoot(4) THEN
               DoSound 2, 4
               FOR t3 = 1 TO 2
                  NewEnShot 1, 1, Enemies(t).X - 18 + 12 * t3, Enemies(t).Y, 0, 8
               NEXT t3
            END IF
         CASE 5
            IF RND > .975 THEN
               Enemies(t).DX = INT(RND * 9) - 4
               Enemies(t).DY = INT(RND * 5) - 2
            END IF
            IF Enemies(t).Y > 100 THEN Enemies(t).DY = Enemies(t).DY - 1
            ShiftEn t
            IF EnShoot(5) THEN
               DoSound 2, 5
               FOR t3 = -2 TO 2
                  NewEnShot INT(RND * 2 + 1), 1, Enemies(t).X + 3 * t3, Enemies(t).Y + 10 - ABS(t3), Enemies(t).DX + t3 + SGN(t3), Enemies(t).DY \ 2 + 7 - ABS(t3) + (ABS(t3) = 2)
               NEXT t3
            END IF
         CASE 6
            EnMotion t, 92, 6, 3
            IF Enemies(t).Y < 20 THEN Enemies(t).DY = Enemies(t).DY + 1
            IF Enemies(t).Y > 70 THEN Enemies(t).DY = Enemies(t).DY - 1
            ShiftEn t
            IF EnShoot(6) THEN
               DoSound 2, 6
               FOR t3 = -1 TO 1 STEP 2
                  NewEnShot 3, 1, Enemies(t).X + 7 * t3, Enemies(t).Y + 5, Enemies(t).DX + t3, Enemies(t).DY + 1
               NEXT t3
            END IF
         CASE 7
            EnMotion t, 90, 4, 2
            IF Enemies(t).Y < 40 THEN Enemies(t).DY = Enemies(t).DY + 1
            IF Enemies(t).Y > 100 THEN Enemies(t).DY = Enemies(t).DY - 1
            ShiftEn t
            IF EnShoot(7) AND Enemies(t).p > 0 THEN Enemies(t).p = Enemies(t).p + 1
         CASE 8
            ShiftEn t
            En8(t) = En8(t) + 1
            IF En8(t) = 7 THEN
               En8(t) = 0
               DoSound 2, 8
               IF Enemies(t).p > 0 THEN Enemies(t).p = Enemies(t).p - 1
               t3 = Enemies(t).Y MOD 42
               NewEnShot -4, 3, Enemies(t).X, Enemies(t).Y - (10 - t3) * (t3 > 10), SGN(Enemies(t).DX), 42
            END IF
         CASE 9
            IF RND > .96 THEN
               Enemies(t).DX = INT(RND * 5 + 2) * (2 * INT(RND * 2) - 1)
               Enemies(t).DY = INT(RND * 5 + 2) * (2 * INT(RND * 2) - 1)
            END IF
            ShiftEn t
            IF EnShoot(9) THEN
               DoSound 2, 1
               XX = (Ship.X - Enemies(t).X): YY = (Ship.Y - Enemies(t).Y)
               t3 = (9 * XX) \ YY: IF ABS(t3) > 8 THEN t3 = 8 * SGN(t3)
               NewEnShot 1, 1, Enemies(t).X, Enemies(t).Y + 10, INT(RND * 3 - 1) + t3, Enemies(t).DY \ 2 + 7
            END IF
         CASE 11, 12
            ShiftMB t
            IF Enemies(t).Y >= 20 THEN
               IF EnShoot(11) AND ABS(Enemies(t).Damage) >= 12 THEN
                  IF INT(RND * 3) = 0 THEN
                     DoSound 2, 2
                     NewEnShot 3, 1, Enemies(t).X, Enemies(t).Y + 15, Enemies(t).DX, Enemies(t).DY + 2
                  ELSE
                     DoSound 2, 1
                     XX = (Ship.X - Enemies(t).X): YY = (Ship.Y - Enemies(t).Y)
                     t3 = (11 * XX) \ YY: IF ABS(t3) > 8 THEN t3 = 8 * SGN(t3)
                     NewEnShot 1, 1, Enemies(t).X - 12 - 24 * (RND > .5), Enemies(t).Y + 7, t3, 8
                  END IF
               END IF
            END IF
         CASE 13, 14
            ShiftMB t
            IF BossExtra(9) > 0 THEN
               BossExtra(9) = BossExtra(9) + 1
               PALETTE 254, LasPal(BossExtra(9))
               IF BossExtra(9) = 10 THEN
                  BossExtra(9) = 0
                  DoSound 2, 8
                  t3 = Enemies(t).Y MOD 42
                  NewEnShot -4, 3, Enemies(t).X, Enemies(t).Y - (10 - t3) * (t3 > 10), SGN(Enemies(t).DX), 42
               END IF
            END IF
            IF Enemies(t).Y >= 20 THEN
               IF EnShoot(13) AND ABS(Enemies(t).Damage) >= 12 THEN
                  IF RND > .5 THEN
                     DoSound 2, 6
                     NewEnShot 3, 1, Enemies(t).X - 14, Enemies(t).Y, Enemies(t).DX - 1, Enemies(t).DY + 2
                     NewEnShot 3, 1, Enemies(t).X + 14, Enemies(t).Y, Enemies(t).DX + 1, Enemies(t).DY + 2
                  ELSE
                     IF BossExtra(9) = 0 THEN BossExtra(9) = 1
                  END IF
               END IF
            END IF
         CASE 15, 16
            ShiftMB t
            IF Enemies(t).Y >= 20 THEN
               IF EnShoot(15) AND ABS(Enemies(t).Damage) >= 12 THEN
                  SELECT CASE INT(RND * 2)
                     CASE 0 ' shells
                        DoSound 2, 3
                        XX = (Ship.X - Enemies(t).X): YY = (Ship.Y - Enemies(t).Y)
                        t3 = (11 * XX) \ YY: IF ABS(t3) > 8 THEN t3 = 8 * SGN(t3)
                        NewEnShot 6, 3, Enemies(t).X - 14, Enemies(t).Y + 12, t3, Enemies(t).DY + 5
                        NewEnShot 6, 3, Enemies(t).X + 14, Enemies(t).Y + 12, t3, Enemies(t).DY + 5
                     CASE ELSE ' shots
                        IF BossExtra(7) <= 0 THEN BossExtra(7) = INT(RND * 20 + 5)
                  END SELECT
               END IF
               IF BossExtra(7) THEN
                  BossExtra(7) = BossExtra(7) - 1
                  IF BossExtra(7) MOD 2 THEN
                     DoSound 2, 1
                     NewEnShot 1, 1, Enemies(t).X, Enemies(t).Y + 15, Enemies(t).DX / 2 + INT(RND * 11 - 6), Enemies(t).DY / 2 + 6 + INT(RND * 3)
                  END IF
               END IF
            END IF
         CASE 17, 18
            ShiftMB t
            IF Enemies(t).Y >= 20 THEN
               IF EnShoot(17) AND ABS(Enemies(t).Damage) >= 12 THEN
                  SELECT CASE INT(RND * 2)
                     CASE 0 ' outer shots
                        t1 = INT(RND * 2)
                        DoSound 2, 4
                        FOR t3 = -1 TO 1 STEP 2
                           NewEnShot 1, 1, Enemies(t).X + t3 * (7 + t1 * 4), Enemies(t).Y + 18 - t1 * 2, Enemies(t).DX + t3 * (t1 + 1), Enemies(t).DY + 7
                        NEXT t3
                     CASE ELSE ' middle shot
                        IF BossExtra(5) = 0 THEN
                           BossExtra(5) = INT(RND * 15 + 5)
                           BossExtra(6) = INT(RND * 9 - 4)
                           BossExtra(7) = INT(RND * 2) * 2 - 1
                           BossExtra(8) = INT(RND * 2 + 1)
                        END IF
                  END SELECT
               END IF
               IF BossExtra(5) THEN
                  BossExtra(5) = BossExtra(5) - 1
                  IF BossExtra(5) MOD BossExtra(8) = 0 THEN
                     DoSound 2, 1
                     NewEnShot 1, 1, Enemies(t).X, Enemies(t).Y + 15, Enemies(t).DX / 2 + BossExtra(6), Enemies(t).DY / 2 + 5
                     BossExtra(6) = BossExtra(6) + BossExtra(7)
                     IF ABS(BossExtra(6)) = 5 THEN BossExtra(7) = -SGN(BossExtra(6)) * INT(RND * 2 + 1)
                  END IF
               END IF
            END IF
      END SELECT
   NEXT t

END SUB

SUB MoveEnShots STATIC

   FOR t = 1 TO MaxEnShots
      H1 = 0
      IF Shots2(t).p THEN
         IF Shots2(t).p < 0 THEN t2 = 3: t3 = 21 ELSE t2 = 5: t3 = 5
         Blank Shots2(t).X, Shots2(t).Y, t2, t3
         Shots2(t).X = Shots2(t).X + Shots2(t).DX
         Shots2(t).Y = Shots2(t).Y + Shots2(t).DY
         YY = Ship.Y - Shots2(t).Y
         IF Shots2(t).p > 0 THEN
            IF ABS(YY) <= 9 AND (ABS(Shots2(t).X - Ship.X) <= 5 - YY \ 2 - (Shields > 0)) THEN H1 = 1
         ELSE
            IF ABS(Shots2(t).X - Ship.X) <= 8 AND ABS(YY) <= 20 THEN H1 = 1
         END IF
         IF H1 AND Dead = 0 THEN
            NoHits = 0
            IF Shields > 0 THEN
               DoSound 4, 1
               Shields = Shields - Shots2(t).Damage
               IF Shields < 0 THEN Shields = 0
               ShPal
            ELSE
               DoSound 4, 2
               Dead = 1
               Explode Ship.X, Ship.Y, Ship.DX, Ship.DY, 1, 0
            END IF
            IF Shots2(t).p = 6 THEN Explode Shots2(t).X, Shots2(t).Y, 0, 2, 0, 0
            IF Shots2(t).p > 0 THEN Shots2(t).p = 0
         END IF
         IF Shots2(t).Y > 194 OR Shots2(t).X < 5 OR Shots2(t).X > 314 OR Shots2(t).Y < 5 THEN Shots2(t).p = 0
         SELECT CASE Shots2(t).p
            CASE 1, 2
               Shots2(t).p = 3 - Shots2(t).p
            CASE 3, 4, 5
               Shots2(t).p = INT(RND * 3 + 3)
               Shots2(t).DX = Shots2(t).DX + SGN(Ship.X - Shots2(t).X)
               IF ABS(Shots2(t).DX) > 7 THEN Shots2(t).DX = 7 * SGN(Shots2(t).DX)
               IF Shots2(t).DY < 9 THEN Shots2(t).DY = Shots2(t).DY + 1
            CASE 6
               IF Shots2(t).DY < 10 THEN Shots2(t).DY = Shots2(t).DY + 1
               FOR t2 = 1 TO MaxShots
                  SELECT CASE Shots1(t2).p
                     CASE 0
                     CASE IS < 0
                        IF ABS(Shots2(t).X - Shots1(t2).X) <= 4 AND ABS(Shots2(t).Y - Shots1(t2).Y) <= 25 THEN
                           DoSound 4, 5
                           ShotsHit = ShotsHit + 1
                           Explode Shots2(t).X, Shots2(t).Y, Shots2(t).DX, Shots2(t).DY, 0, 0
                           Shots2(t).p = 0
                           Score = Score + 50
                        END IF
                     CASE 1 TO 6
                        IF ABS(Shots2(t).X - Shots1(t2).X) <= 5 AND ABS(Shots2(t).Y - Shots1(t2).Y) <= 10 THEN
                           DoSound 4, 5
                           Explode Shots2(t).X, Shots2(t).Y, Shots2(t).DX, Shots2(t).DY, 0, 0
                           Shots2(t).p = 0
                           Shots1(t2).p = 0
                           Blank Shots1(t2).X, Shots1(t2).Y, Shots1(t2).XSize \ 2, Shots1(t2).YSize \ 2
                           Score = Score + 50
                        END IF
                  END SELECT
               NEXT t2
         END SELECT
      END IF
      IF Shots2(t).p > 0 THEN
         PUT (Shots2(t).X - Shots2(t).XSize \ 2, Shots2(t).Y - Shots2(t).YSize \ 2), EnShotPics(52 * (Shots2(t).p - 1)), OR
      ELSEIF Shots2(t).p < 0 AND Shots2(t).Y <= 178 THEN
         PUT (Shots2(t).X - 5 \ 2, Shots2(t).Y - 42 \ 2), LasPics(107 * (-Shots2(t).p - 1)), OR
         'VPUT Shots2(t).X - 5 \ 2, Shots2(t).Y - 42 \ 2, LasPics(), 107 * (-Shots2(t).p - 1), 4
      END IF
   NEXT t

END SUB

SUB MoveGoodies STATIC

FOR t = 1 TO MaxGoodies
   IF Goodies(t).p > 0 THEN
      Blank Goodies(t).X, Goodies(t).Y, 5, 5
      Goodies(t).X = Goodies(t).X + Goodies(t).DX
      Goodies(t).Y = Goodies(t).Y + Goodies(t).DY
      IF Dist(Goodies(t), Ship) <= 12 AND Dead = 0 THEN ' get goodie
         IF Goodies(t).p > 3 THEN DoSound 3, Goodies(t).p
         SELECT CASE Goodies(t).p
            CASE 1, 2, 3
               t2 = Goodies(t).p * 3 - 2
               FOR t3 = t2 TO t2 + 2
                  IF Weap(t3).Avail = 0 OR t3 = t2 + 2 THEN
                     DoSound 3, 1 - t2 + t3
                     Weap(t3).Avail = Weap(t3).MaxAmmo
                     CurrWeap = t3
                     IF Weap(t3).Automatic THEN ShotOK = 1
                     EXIT FOR
                  ELSE
                     Weap(t3).Avail = Weap(t3).MaxAmmo
                  END IF
               NEXT t3
               LINE (124, 192)-(200, 199), 0, BF ' remove "ammo low" sign
            CASE 4
               IF Bombs < 10 THEN Bombs = Bombs + 1
            CASE 5
               Speed = Speed + 1
            CASE 6
               Lives = Lives + 1
            CASE 7
               SELECT CASE Shields
                  CASE 0 TO 1
                     Shields = 2
                  CASE 2 TO 4
                     Shields = 5
                  CASE 5 TO 9
                     Shields = 10
                  CASE IS >= 10
                     Shields = 15
               END SELECT
               ShPal
         END SELECT
         Goodies(t).p = 0
      ELSEIF Goodies(t).Y > 189 THEN
         Goodies(t).p = 0
      END IF
   END IF

   IF Goodies(t).p > 0 THEN PUT (Goodies(t).X - 5, Goodies(t).Y - 5), GoodiesPics(52 * (Goodies(t).p - 1)), PSET
NEXT t


END SUB

SUB MoveShip STATIC


IF Dead = 0 THEN
   Blank Ship.X, Ship.Y, Ship.XSize \ 2, 0
   IF K(5) = 1 AND K(4) = 0 THEN
      Ship.DX = Ship.DX + 2
      IF Ship.DX > Speed THEN Ship.DX = Speed
   ELSEIF K(4) = 1 AND K(5) = 0 THEN
      Ship.DX = Ship.DX - 2
      IF Ship.DX < -Speed THEN Ship.DX = -Speed
   END IF
   Ship.X = Ship.X + Ship.DX
   IF Ship.X < 20 THEN Ship.X = 20
   IF Ship.X > 300 THEN Ship.X = 300
   PUT (Ship.X - Ship.XSize \ 2, Ship.Y - Ship.YSize \ 2), ShipPics(202 * Weap(CurrWeap).Shipp - 808 * (Shields > 0)), PSET
  
   Ship.DX = Ship.DX - SGN(Ship.DX)
   Ship.DY = Ship.DY - SGN(Ship.DY)
ELSEIF Dead = 49 THEN
   FOR t = 2 TO 9: Weap(t).Avail = 0: NEXT t
   CurrWeap = 1: Speed = 6: Bombs = 1: Shields = 2
   Dead = 50
ELSEIF Dead = 50 THEN
   IF Lives > 0 THEN
      Lives = Lives - 1: Dead = Dead + 1
      Ship.X = 160: Ship.Y = 210
      Ship.DX = 0: Ship.DY = -2
      NumEn = 0: NumMB = 0
      FOR t = 1 TO MaxEnShots
         Shots2(t).p = 0
      NEXT t
      FOR t = 1 TO MaxShots
         Shots1(t).p = 0
      NEXT t
      FOR t = 1 TO MaxObj
         Enemies(t).p = 0
      NEXT t
      FOR t = 1 TO MaxGoodies
         Goodies(t).p = 0
      NEXT t
      InitStars
      CLS
      LevCounter = SaveLevel: IF LevCounter = 0 THEN LevCounter = 1
      CounterDat = 0: Counter = 0
      ShotOK = 0: SB = 0
      ShPal
      NewGoodie INT(RND * 280 + 20), 10, INT(RND * 7 + 1)
   ELSE
      Dead = -1
   END IF
ELSEIF Dead = 51 THEN
   Blank Ship.X, Ship.Y, Ship.XSize \ 2, 0
   Ship.X = Ship.X + Ship.DX
   Ship.Y = Ship.Y + Ship.DY
   VPutINT Ship.X - Ship.XSize \ 2, Ship.Y - Ship.YSize \ 2, ShipPics(), 202 * Weap(CurrWeap).Shipp - 808 * (Shields > 0), 1, 0, 199
   PUT (144, 79), GoodiesPics(52 * 5), PSET
   Text 2, 159, 80, 0, 0, "x" + STR$(Lives), 3
   RotateFontPal 2
   IF Ship.Y <= 180 THEN
      Ship.DY = 0: Dead = 0
      LINE (144, 79)-(184, 89), 0, BF
      FontPC(2) = 1
   END IF
ELSEIF Dead = 1 THEN
   NoDeath = 0
   Dead = 2
ELSEIF Dead >= 2 THEN
   Dead = Dead + 1
'   PUT (144, 79), GoodiesPics(52 * 5), PSET
'   Text 2, 159, 80, 0, 0, "x" + STR$(Lives), 3
'   RotateFontPal 2
END IF

END SUB

SUB MoveShots STATIC

   FOR t = 1 TO MaxShots
      SELECT CASE Shots1(t).p
         CASE 1, 2, 3
            Blank Shots1(t).X, Shots1(t).Y, Shots1(t).XSize \ 2, Shots1(t).YSize \ 2
            Shots1(t).X = Shots1(t).X + Shots1(t).DX
            Shots1(t).Y = Shots1(t).Y + Shots1(t).DY
            IF Shots1(t).Y < 5 OR Shots1(t).X < 5 OR Shots1(t).X > 314 THEN Shots1(t).p = 0
            FOR t2 = 1 TO MaxEn
               IF Enemies(t2).p > 10 THEN t3 = 18 ELSE t3 = 10
               IF Enemies(t2).p > 0 THEN
                  IF Dist(Enemies(t2), Shots1(t)) <= t3 THEN
                     HitEnemy t2, t, 1
                     Shots1(t).p = 0
                     Blank Shots1(t).X, Shots1(t).Y, Shots1(t).XSize \ 2, Shots1(t).YSize \ 2
                     EXIT FOR
                  END IF
               END IF
            NEXT t2
            IF Shots1(t).DY > -10 THEN Shots1(t).DY = Shots1(t).DY - 1
         CASE 4, 5, 6
            Blank Shots1(t).X, Shots1(t).Y, Shots1(t).XSize \ 2, Shots1(t).YSize \ 2
            Shots1(t).X = Shots1(t).X + Shots1(t).DX
            Shots1(t).Y = Shots1(t).Y + Shots1(t).DY
            IF Shots1(t).Y < 5 OR Shots1(t).X < 5 OR Shots1(t).X > 314 THEN Shots1(t).p = 0
            FOR t2 = 1 TO MaxEn
               IF Enemies(t2).p > 10 THEN t3 = 17 ELSE t3 = 10
               IF Enemies(t2).p > 0 THEN
                  IF Dist(Enemies(t2), Shots1(t)) <= t3 THEN
                     HitEnemy t2, t, 1
                     Shots1(t).p = 0
                     Blank Shots1(t).X, Shots1(t).Y, Shots1(t).XSize \ 2, Shots1(t).YSize \ 2
                     EXIT FOR
                  END IF
               END IF
            NEXT t2
         CASE 7
            Blank Shots1(t).X, Shots1(t).Y, Shots1(t).XSize \ 2, Shots1(t).YSize \ 2
            Shots1(t).X = Shots1(t).X + Shots1(t).DX
            Shots1(t).Y = Shots1(t).Y + Shots1(t).DY
            IF Shots1(t).Y <= 75 THEN
               DoSound 4, 4
               PALETTE 0, 63 + 63 * 256 + 63 * 65536
               PFC = 5
               Boss.Damage = Shots1(t).Damage - Boss.Damage
               FOR t2 = 1 TO MaxEn
                  IF Enemies(t2).p > 0 THEN
                     HitEnemy t2, t, 0
                  END IF
               NEXT t2
               FOR t2 = 1 TO MaxEnShots
                   IF Shots2(t2).p > 0 THEN
                      Blank Shots2(t2).X, Shots2(t2).Y, Shots2(t2).XSize, 0
                      IF Shots2(t2).p = 6 THEN Explode Shots2(t2).X, Shots2(t2).Y, Shots2(t2).DX, Shots2(t2).DY, 0, 0
                      Shots2(t2).p = 0
                  END IF
               NEXT t2
               Shots1(t).p = 0
               Explode Shots1(t).X, Shots1(t).Y, Shots1(t).DX, Shots1(t).DY, 1, 0
            END IF
         CASE -1, -2, -3
            Blank Shots1(t).X, Shots1(t).Y, Shots1(t).XSize \ 2, Shots1(t).YSize \ 2
            Shots1(t).X = Shots1(t).X + Shots1(t).DX
            Shots1(t).Y = Shots1(t).Y + Shots1(t).DY
            IF Shots1(t).Y < 21 OR Shots1(t).X < 2 OR Shots1(t).X > 317 THEN Shots1(t).p = 0
            FOR t2 = 1 TO MaxEn
               IF Enemies(t2).p > 10 THEN t3 = 16 ELSE t3 = 8
               IF Enemies(t2).p > 0 THEN
                  IF ABS(Enemies(t2).X - Shots1(t).X) <= t3 AND ABS(Enemies(t2).Y - Shots1(t).Y) <= 15 + t3 THEN HitEnemy t2, t, 1
               END IF
            NEXT t2
  
      END SELECT
      IF Shots1(t).p > 0 THEN
         PUT (Shots1(t).X - Shots1(t).XSize \ 2, Shots1(t).Y - Shots1(t).YSize \ 2), ShotPics(52 * (Shots1(t).p - 1)), OR
      ELSEIF Shots1(t).p < 0 THEN
         PUT (Shots1(t).X - Shots1(t).XSize \ 2, Shots1(t).Y - Shots1(t).YSize \ 2), LasPics(107 * (-Shots1(t).p - 1)), OR
      END IF
   NEXT t


END SUB

SUB MoveStars STATIC

FOR t = 1 TO NumStars
   IF Stars(t).Damage >= Stars(t).DY THEN
      PRESET (Stars(t).X, Stars(t).Y)
      Stars(t).Y = Stars(t).Y + 1
      IF Stars(t).Y > 199 THEN
         NewStar t
      ELSE
         PSET (Stars(t).X, Stars(t).Y), Stars(t).p
      END IF
      Stars(t).Damage = 1
   ELSE
      Stars(t).Damage = Stars(t).Damage + 1
   END IF
NEXT t


END SUB

SUB MoveStars2 (BGCol AS INTEGER) STATIC

FOR t = 1 TO NumStars
   IF Stars(t).Damage >= Stars(t).DY THEN
      IF Stars(t).g THEN PSET (Stars(t).X, Stars(t).Y), BGCol
      Stars(t).Y = Stars(t).Y + 1
      IF Stars(t).Y > 199 THEN
         NewStar t
      ELSE
         IF POINT(Stars(t).X, Stars(t).Y) <> BGCol THEN
            Stars(t).g = 0
         ELSE
            PSET (Stars(t).X, Stars(t).Y), Stars(t).p
            Stars(t).g = 1
         END IF
      END IF
      Stars(t).Damage = 1
   ELSE
      Stars(t).Damage = Stars(t).Damage + 1
   END IF
NEXT t

END SUB

SUB NewBoss

FOR t = 1 TO 10: BossExtra(t) = 0: NEXT t
Boss.X = INT(RND * 220) + 50: Boss.Y = -25
Boss.DX = 0: Boss.DY = 3
Boss.Damage = BossData(Level)
Boss.p = 1
IF Level = 4 THEN PALETTE 254, LasPal(0)
IF Level = 5 THEN BossExtra(9) = 1

END SUB

SUB NewEnemy (X AS INTEGER, Y AS INTEGER, p AS INTEGER, g AS INTEGER)

t = NextFreeObj(Enemies(), 0, MaxEn)
IF t THEN
  
   IF p THEN
      Enemies(t).p = p
   ELSE
      Enemies(t).p = INT(RND * 8 + 1)
      IF Enemies(t).p = 8 THEN Enemies(t).p = 9
   END IF

   IF Y > 200 THEN Y = Y - 255

   Enemies(t).Damage = EnData(1, Enemies(t).p)
   Enemies(t).XSize = EnData(3, Enemies(t).p): Enemies(t).YSize = Enemies(t).XSize
   Enemies(t).X = X: Enemies(t).Y = Y
   Enemies(t).DX = INT(RND * 5 - 2): Enemies(t).DY = INT(RND * 5 - 2)

   IF g = 10 THEN Enemies(t).g = INT(RND * 7 + 1) ELSE Enemies(t).g = g
   
   NumEn = NumEn + 1


   IF X = 0 AND Y = 0 THEN
      SELECT CASE INT(RND * 3)
         CASE 0
            Enemies(t).X = INT(RND * 280 + 20)
            Enemies(t).Y = 10
            Enemies(t).DY = 2
            Enemies(t).DX = INT(RND * 5) - 2
         CASE 1
            Enemies(t).X = 10
            Enemies(t).Y = INT(RND * 90 + 20)
            Enemies(t).DY = INT(RND * 5) - 2
            Enemies(t).DX = 2
         CASE 2
            Enemies(t).X = 309
            Enemies(t).Y = INT(RND * 90 + 20)
            Enemies(t).DY = INT(RND * 5) - 2
            Enemies(t).DX = -2
      END SELECT
   ELSEIF X = 0 THEN
      Enemies(t).X = INT(RND * 260 + 30)
      Enemies(t).DY = 2
      Enemies(t).DX = INT(RND * 5) - 2
   ELSEIF Y = 0 THEN
      Enemies(t).Y = INT(RND * 90 + 20)
      Enemies(t).DX = INT(RND * 5 - 2)
      Enemies(t).DY = INT(RND * 5 - 2)
   END IF
   IF p > 10 THEN
      Enemies(t).DY = 2: Enemies(t).DX = 0: NumMB = NumMB + 1
   END IF
   IF p = 13 THEN BossExtra(9) = 0: PALETTE 254, LasPal(0)
ELSE
   LevCounter = LevCounter - 5
   CounterDat = 10
   Counter = 0
END IF


END SUB

SUB NewEnShot (p AS INTEGER, Dam AS INTEGER, X AS INTEGER, Y AS INTEGER, DX AS INTEGER, DY AS INTEGER) STATIC

t2 = NextFreeObj(Shots2(), 0, MaxEnShots)
IF t2 THEN
   IF Dead = 0 THEN Shots2(t2).p = p
   Shots2(t2).Damage = Dam
   Shots2(t2).X = X
   Shots2(t2).Y = Y
   Shots2(t2).DX = DX
   Shots2(t2).DY = DY
END IF

END SUB

SUB NewGoodie (x1 AS INTEGER, y1 AS INTEGER, n AS INTEGER)

IF n = 0 THEN n = INT(RND * 7 + 1)
t = NextFreeObj(Goodies(), 0, MaxGoodies)
IF t THEN
   Goodies(t).p = n
   IF x1 = 0 THEN
      Goodies(t).X = INT(RND * 280 + 20)
   ELSE
      Goodies(t).X = x1
   END IF
   Goodies(t).Y = y1
   Goodies(t).DX = 0
   Goodies(t).DY = 2
   IF Goodies(t).Y < 5 THEN Goodies(t).Y = 5
   IF Goodies(t).X < 10 THEN
      Goodies(t).X = 10
   ELSEIF Goodies(t).X > 309 THEN
      Goodies(t).X = 309
   END IF
END IF

END SUB

SUB NewLevel

DO: LOOP UNTIL INKEY$ = ""
CLS

IF Level > 0 THEN ' give score bonuses
   C = 0
   y1 = 50
   HitRatio& = CLNG((ShotsHit / ShotsFired) * 10000)
   HitBonus& = CLNG((HitRatio& / 100) / 50 * (HitRatio& / 100) * Level) * 50
   Text 1, 100, 20, 0, 0, "LEVEL" + STR$(Level) + " CLEARED", 1
   
   DO
      OP = PEEK(284): DEF SEG
      C = C + 1

      SELECT CASE C
         CASE 1
            IF NoDeath = 0 THEN
               C = 59
            ELSE
               Text 1, 60, y1, 0, 0, "NO DEATH BONUS", 1
               IF Ex1 = 1 THEN C = 19
            END IF
         CASE 20
            Text 2, 200, y1, 0, 0, STR$(NoDeath), 5
            Score = Score + NoDeath
            y1 = y1 + 20
            IF Ex1 = 1 THEN C = 59
         CASE 60
            IF NoHits = 0 THEN
               C = 119
            ELSE
               Text 1, 60, y1, 0, 0, "NO DAMAGE BONUS", 1
               IF Ex1 = 1 THEN C = 79
            END IF
         CASE 80
            Text 2, 200, y1, 0, 0, STR$(NoHits), 5
            Score = Score + NoHits
            y1 = y1 + 20
            IF Ex1 = 1 THEN C = 119
         CASE 120
            Text 1, 100, y1, 0, 0, "shots fired", 1
            IF Ex1 = 1 THEN C = 139
         CASE 140
            Text 2, 200, y1, 0, 0, STR$(ShotsFired), 5
            y1 = y1 + 10
            IF Ex1 = 1 THEN C = 179
         CASE 180
            Text 1, 100, y1, 0, 0, "hit ratio", 1
            IF Ex1 = 1 THEN C = 199
         CASE 200
            Text 2, 200, y1, 0, 0, STR$(HitRatio& / 100) + "%", 5
            y1 = y1 + 15
            IF Ex1 = 1 THEN C = 239
         CASE 240
            Text 1, 100, y1, 0, 0, "BONUS", 1
            IF Ex1 = 1 THEN C = 259
         CASE 260
            Text 2, 200, y1, 0, 0, STR$(HitBonus&), 5
            Score = Score + HitBonus&
            y1 = y1 + 50
            IF Ex1 = 1 THEN C = 499
         CASE 500
            Text 2, 120, 160, 0, 0, "press any key . . .", 5
         CASE 1000
            Ex1 = 1
      END SELECT
     
      IF INKEY$ <> "" THEN
         IF Ex1 = 0 THEN
            Ex1 = 1
            t2 = C \ 20
            IF t2 MOD 3 = 1 THEN
               C = (t2 + 1) * 20 + 19
            ELSE
               C = (t2 + 1) * 20 - 1
            END IF
            IF C > 260 THEN Ex1 = 2
         ELSE
            IF C >= 500 THEN Ex1 = 2
         END IF
      END IF

      Text 0, 0, 0, 0, 0, STR$(Score), 2
     
      StarPalLoop C, 1
   LOOP UNTIL Ex1 = 2
   Ex1 = 0

   IF Level = 5 THEN Ex1 = 10: EXIT SUB

END IF

'CLS
Level = Level + 1
f1$ = "boss" + RTRIM$(LTRIM$(STR$(Level)))
DEF SEG = VARSEG(BossPics(0)): BLOAD f1$ + ".qbs", VARPTR(BossPics(0))
DEF SEG = VARSEG(BossDams(0)): BLOAD f1$ + ".dam", VARPTR(BossDams(0))
IF Level = 5 THEN
   DEF SEG = VARSEG(ZapPics(0)): BLOAD "zap2.qbs", VARPTR(ZapPics(0))
END IF
DEF SEG


' read level
OPEN "levels.dat" FOR RANDOM AS #1 LEN = 800
FIELD #1, 800 AS f$: GET #1, Level
C = 0: DO: C = C + 1: LevelData(C) = ASC(MID$(f$, C, 1))
LOOP UNTIL LevelData(C) = 255
CLOSE #1

LevCounter = 1: SaveLevel = 1
CounterDat = 0: Counter = 0

Ship.X = 160: Ship.Y = 180
Ship.DX = 0: Ship.DY = 0
Lives = Lives + 1: Dead = 50: NoDeath = 1000 * Level: NoHits = 5000 * Level
ShotsFired = 0: ShotsHit = 0
FontPC(0) = 0: FontPC(1) = 0: FontPC(2) = 0
RotateFontPal 0: RotateFontPal 1: RotateFontPal 2

END SUB

SUB NewStar (n AS INTEGER)
   Stars(n).X = INT(RND * 320)
   Stars(n).Y = 0
   Stars(n).DY = INT(RND * 11 + 2) \ 2
   Stars(n).p = INT(RND * 12) + 112
END SUB

FUNCTION NextByte STATIC

LevCounter = LevCounter + 1
NextByte = LevelData(LevCounter)

END FUNCTION

FUNCTION NextFreeObj (A() AS ObjType, Min AS INTEGER, Max AS INTEGER) STATIC

t = Min
DO
   t = t + 1
LOOP UNTIL A(t).p = 0 OR t > Max
IF t <= Max THEN NextFreeObj = t ELSE NextFreeObj = 0

END FUNCTION

SUB RotateFontPal (Batch AS INTEGER) STATIC

C1 = Batch * 4 + 1: C2 = C1 + 3
FontPC(Batch) = FontPC(Batch) MOD 20 + 1
REDIM Temp2(C1 TO C2) AS Colour
FOR t = C1 TO C2
   Temp2(t).Red = FontCol(Batch).Red * FontPal(FontPC(Batch), t - Batch * 4)
   Temp2(t).Green = FontCol(Batch).Green * FontPal(FontPC(Batch), t - Batch * 4)
   Temp2(t).Blue = FontCol(Batch).Blue * FontPal(FontPC(Batch), t - Batch * 4)
NEXT t
SetPalette Temp2(), C1, C2

END SUB

SUB SetPalette (PalArray() AS Colour, C1 AS INTEGER, C2 AS INTEGER) STATIC

DEF SEG : OUT &H3C8, C1
FOR t = C1 TO C2
   OUT &H3C9, PalArray(t).Red
   OUT &H3C9, PalArray(t).Green
   OUT &H3C9, PalArray(t).Blue
NEXT t

END SUB

SUB ShiftBoss STATIC

   IF RND * 100 > BossMoves(Level, 1) AND Boss.Y >= 25 THEN
      Boss.DX = Boss.DX + INT(RND * 3 - 1)
      Boss.DY = Boss.DY + INT(RND * 3 - 1)
   END IF
   IF ABS(Boss.DX) > BossMoves(Level, 2) THEN Boss.DX = Boss.DX - SGN(Boss.DX)
   IF ABS(Boss.DY) > BossMoves(Level, 3) THEN Boss.DY = Boss.DY - SGN(Boss.DY)
   FOR t2 = 1 TO MaxObj
      IF Enemies(t2).p < 0 AND Enemies(t2).g = -1 THEN Blank Enemies(t2).X, Enemies(t2).Y, Enemies(t2).XSize, 0
   NEXT t2


   Blank Boss.X, Boss.Y, 35, 25
   Boss.X = Boss.X + Boss.DX
   Boss.Y = Boss.Y + Boss.DY
   IF Boss.Y >= 25 THEN
      IF Boss.X < 35 THEN Boss.X = 35: Boss.DX = -Boss.DX
      IF Boss.X > 284 THEN Boss.X = 284: Boss.DX = -Boss.DX
      IF Boss.Y < 30 THEN Boss.Y = Boss.Y + 1: Boss.DY = Boss.DY + 1
      IF Boss.Y > 60 THEN Boss.Y = 60: Boss.DY = -Boss.DY
      IF Boss.Damage <= 0 THEN
         PUT (Boss.X - 35, Boss.Y - 25), BossDams(BossExtra(1) * 1752), PSET
         ' Boss.Damage = -Boss.Damage
      ELSE
         PUT (Boss.X - 35, Boss.Y - 25), BossPics(BossExtra(1) * 1752), PSET
      END IF
   ELSE
      Boss.DY = 3
      IF Boss.Damage <= 0 THEN
         VPutINT Boss.X - 35, Boss.Y - 25, BossDams(), BossExtra(1) * 1752, 1, 0, 199
         ' Boss.Damage = -Boss.Damage
      ELSE
         VPutINT Boss.X - 35, Boss.Y - 25, BossPics(), 0, 1, 0, 199
      END IF
   END IF
   IF Level = 5 AND BossExtra(9) THEN
      IF Boss.Damage <= 0 THEN t2 = 135 ELSE t2 = 0
      IF Boss.Y >= 25 THEN
         PUT (Boss.X - 6, Boss.Y + 5), B5FPics(t2), PSET
      ELSE
         VPutINT Boss.X - 6, Boss.Y + 5, B5FPics(), CLNG(t2), 1, 0, 199
      END IF
   END IF
   Boss.Damage = ABS(Boss.Damage)
   IF Boss.p < -20 THEN
      FOR t = 1 TO MaxObj
         IF Enemies(t).p < 0 AND Enemies(t).g = -1 THEN Enemies(t).g = 0
      NEXT t
      DoSound 4, 5: DoSound 4, 4
      FOR x1 = Boss.X - 25 TO Boss.X + 25 STEP 25
         FOR y1 = Boss.Y - 14 TO Boss.Y + 11 STEP 25
            Explode x1 + INT(RND * 7 - 3), y1 + INT(RND * 7 - 3), Enemies(t).DX + SGN(x1), Boss.DY + SGN(y1), 1, 0
         NEXT y1
      NEXT x1
      CounterDat = 0
      NewGoodie Boss.X - 20, Boss.Y, INT(RND * 3 + 5)
      NewGoodie Boss.X, Boss.Y, INT(RND * 7 + 1)
      NewGoodie Boss.X + 20, Boss.Y, INT(RND * 4 + 1)
      Score = Score + ScoreData(-Level)
   ELSEIF ABS(Boss.Damage) <= 20 AND INT(RND * Boss.Damage \ 3) = 0 THEN
      Boss.p = Boss.p - 1: Boss.Damage = Boss.Damage - 1
      IF Level = 3 THEN BossExtra(1) = 2
      t3 = INT(RND * 2)
      DoSound 4, 3
      Explode Boss.X + INT(RND * 61 - 30), Boss.Y + INT(RND * 41 - 20), 0, 0, t3, -1
   END IF

END SUB

SUB ShiftEn (n AS INTEGER) STATIC
           
   Blank Enemies(n).X, Enemies(n).Y, Enemies(n).XSize \ 2, 0
   Enemies(n).X = Enemies(n).X + Enemies(n).DX
   Enemies(n).Y = Enemies(n).Y + Enemies(n).DY
   CheckEnPos n
   IF Enemies(n).Damage <= 0 THEN
      PUT (Enemies(n).X - Enemies(n).XSize \ 2, Enemies(n).Y - Enemies(n).YSize \ 2), EnDams(202 * (Enemies(n).p - 1)), PSET
      Enemies(n).Damage = -Enemies(n).Damage
   ELSE
      PUT (Enemies(n).X - Enemies(n).XSize \ 2, Enemies(n).Y - Enemies(n).YSize \ 2), EnPics(202 * (Enemies(n).p - 1)), PSET
   END IF
   IF Enemies(n).Damage = 0 THEN
      Enemies(n).p = -11
      NumEn = NumEn - 1
      IF Enemies(n).g THEN
         NewGoodie Enemies(n).X, Enemies(n).Y, Enemies(n).g
      ELSEIF NumEn = 0 AND LastGoodie THEN
         NewGoodie Enemies(n).X, Enemies(n).Y, LastGoodie
         LastGoodie = 0
      ELSE
         IF 100 * RND <= GoodieChance THEN NewGoodie Enemies(n).X, Enemies(n).Y, 0
      END IF
      Enemies(n).g = 0
      IF (NumEn <= -CounterDat) OR (NumEn = 0 AND (CounterDat = 1 OR CounterDat = 4)) THEN CounterDat = 0: Counter = 0
   END IF

END SUB

SUB ShiftMB (n AS INTEGER) STATIC

   t2 = (Enemies(n).p - 9) / 2
   IF 100 * RND > MBMoves(t2, 1) AND Enemies(n).Y >= 20 THEN
      Enemies(n).DX = Enemies(n).DX + INT(RND * 3 - 1)
      Enemies(n).DY = Enemies(n).DY + INT(RND * 3 - 1)
   END IF
   IF ABS(Enemies(n).DX) > MBMoves(t2, 2) THEN Enemies(n).DX = Enemies(n).DX - SGN(Enemies(n).DX)
   IF ABS(Enemies(n).DY) > MBMoves(t2, 3) THEN Enemies(n).DY = Enemies(n).DY - SGN(Enemies(n).DY)
  
   FOR t2 = 1 TO MaxObj
      IF Enemies(t2).p < 0 AND Enemies(t2).g = n THEN Blank Enemies(t2).X, Enemies(t2).Y, Enemies(t2).XSize, 0
   NEXT t2

   Blank Enemies(n).X, Enemies(n).Y, Enemies(n).XSize \ 2, 0
   Enemies(n).X = Enemies(n).X + Enemies(n).DX
   Enemies(n).Y = Enemies(n).Y + Enemies(n).DY
   IF Enemies(n).Y >= 20 THEN
      CheckMBPos n
      IF Enemies(n).Damage <= 0 THEN
         PUT (Enemies(n).X - Enemies(n).XSize \ 2, Enemies(n).Y - Enemies(n).YSize \ 2), MBDams(802 * (Enemies(n).p - 11)), PSET
         Enemies(n).Damage = -Enemies(n).Damage
      ELSE
         PUT (Enemies(n).X - Enemies(n).XSize \ 2, Enemies(n).Y - Enemies(n).YSize \ 2), MBPics(802 * (Enemies(n).p - 11)), PSET
      END IF
   ELSE
      Enemies(n).DY = 2
      IF Enemies(n).Damage <= 0 THEN
         VPutINT Enemies(n).X - Enemies(n).XSize \ 2, Enemies(n).Y - Enemies(n).YSize \ 2, MBDams(), 802 * (Enemies(n).p - 11), 1, 0, 199
         Enemies(n).Damage = -Enemies(n).Damage
      ELSE
         VPutINT Enemies(n).X - Enemies(n).XSize \ 2, Enemies(n).Y - Enemies(n).YSize \ 2, MBPics(), 802 * (Enemies(n).p - 11), 1, 0, 199
      END IF
   END IF
   IF Enemies(n).Damage = 0 THEN
      FOR t = 1 TO MaxObj
         IF Enemies(t).p < 0 AND Enemies(t).g = n THEN Enemies(t).g = 0
      NEXT t
      Score = Score + ScoreData(Enemies(n).p)
      Enemies(n).p = -11
      NumEn = NumEn - 1: NumMB = NumMB - 1
      DoSound 4, 4
      FOR x1 = Enemies(n).X - 10 TO Enemies(n).X + 10 STEP 20
         FOR y1 = Enemies(n).Y - 10 TO Enemies(n).Y + 10 STEP 20
            Explode x1 + INT(RND * 9 - 4), y1 + INT(RND * 9 - 4), Enemies(t).DX + SGN(x1), Enemies(n).DY + SGN(y1), 1, 0
         NEXT y1
      NEXT x1
      IF Enemies(n).g THEN
         NewGoodie Enemies(n).X, Enemies(n).Y, Enemies(n).g
      ELSEIF NumEn = 0 AND LastGoodie THEN
         NewGoodie Enemies(n).X, Enemies(n).Y, LastGoodie
         LastGoodie = 0
      ELSE
         IF 100 * RND <= GoodieChance THEN NewGoodie Enemies(n).X, Enemies(n).Y, 0
      END IF

      IF (NumEn <= -CounterDat) OR (NumEn = 0 AND (CounterDat = 1 OR CounterDat = 4)) THEN CounterDat = 0: Counter = 0
   ELSEIF ABS(Enemies(n).Damage) <= 12 AND INT(RND * Enemies(n).Damage \ 2) = 0 THEN
      SELECT CASE Enemies(n).p
         CASE 11, 13, 15, 17
            IF Enemies(n).Damage <= 12 THEN
               DoSound 4, 4
               Enemies(n).Damage = 11
               Explode Enemies(n).X, Enemies(n).Y + 8, Enemies(n).DX, Enemies(n).DY, 1, n
               Enemies(n).p = Enemies(n).p + 1
            END IF
      END SELECT
      DoSound 4, 3
      t3 = INT(RND * 2)
      Explode Enemies(n).X + INT(RND * 31 - 15), Enemies(n).Y + INT(RND * 31 - 15), 0, 0, t3, n
      Enemies(n).Damage = Enemies(n).Damage - 1
   END IF

END SUB

SUB ShPal STATIC
   REDIM Temp(13 TO 15) AS Colour
   FOR t = 13 TO 15
      Temp(t) = ShieldPal(t - 12, Shields)
   NEXT t
   SetPalette Temp(), 13, 15

END SUB

SUB StarPalLoop (C AS INTEGER, st AS INTEGER)

         IF st THEN MoveStars2 0
  
         RotateFontPal 1
         IF C MOD 2 THEN RotateFontPal 2
         IF C MOD 3 = 0 THEN RotateFontPal 0

         DEF SEG = 53
         DO: LOOP UNTIL PEEK(284) <> OP

END SUB

SUB StatusScreen

x1 = 90: y1 = 66: y2 = 28
xc = 160: yc = 86
REDIM Temp(((2 * x1 + 1) * (2 * y1 + 1) + 4) \ 2) AS INTEGER
GET (xc - x1, yc - y1)-(xc + x1, yc + y1), Temp(0)

FOR t = -3 TO 3
   LINE (xc + 3 - x1 + t, yc + 3 - y1 + t)-(xc - 3 + x1 - t, yc - 3 + y1 - t), 112 + ABS(t) * 3 + 5, B
NEXT t
LINE (xc + 7 - x1, yc + 7 - y1)-(xc - 7 + x1, yc - 7 + y1), 0, BF
FOR t = -3 TO 3
   LINE (xc + 3 - x1 + ABS(t), y2 + 15 + t)-(xc - 3 + x1 - ABS(t), y2 + 15 + t), 112 + ABS(t) * 3 + 5
NEXT t

FOR t = 36 TO 45
   Text TextDat(t, 1), TextDat(t, 2), y2 + TextDat(t, 3), 0, 0, TextStr(t), TextDat(t, 4)
NEXT t

Text 1, 200, y2 + 20, 0, 0, STR$(Level), 6
Text 1, 200, y2 + 31, 0, 0, STR$(Lives), 6
FOR t = 0 TO 2
   PUT (84, y2 + t * 11 + 54), GoodiesPics(t * 52), PSET
NEXT t
PUT (84, y2 + 89), GoodiesPics(3 * 52), PSET
FOR t = 0 TO 2
   t3 = 0
   FOR t2 = 3 TO 1 STEP -1
      IF Weap(t * 3 + t2).Avail THEN
         t3 = 1
         Text 1, 190, y2 + 54 + 11 * t, 0, 0, STR$(t2), 6
         s$ = RTRIM$(LTRIM$(STR$(INT(Weap(t * 3 + t2).Avail / Weap(t * 3 + t2).MaxAmmo * 100))))
         IF s$ <> "0" THEN Text 2, 210 + (3 - LEN(s$)) * 7, y2 + 54 + 11 * t, 0, 0, s$ + "%", 3
         EXIT FOR
      END IF
      IF t3 = 0 THEN Text 1, 190, y2 + 54 + 11 * t, 0, 0, STR$(0), 6
   NEXT t2
NEXT t
Text 1, 190, y2 + 89, 0, 0, STR$(Bombs), 6


DO
   OP = PEEK(284): DEF SEG
   C& = C& + 1
   SELECT CASE UCASE$(INKEY$)
      CASE IS <> ""
         Ex1 = 1
   END SELECT
   StarPalLoop CINT(C&), 0
LOOP UNTIL Ex1
Ex1 = 0

PUT (xc - x1, yc - y1), Temp(0), PSET

END SUB

SUB Text (Batch AS INTEGER, x1 AS INTEGER, y1 AS INTEGER, x2 AS INTEGER, y2 AS INTEGER, Message AS STRING, Col AS INTEGER) STATIC

DIM FontCol2 AS Colour
FontCol2.Red = Col AND 1
FontCol2.Green = (Col AND 2) \ 2
FontCol2.Blue = (Col AND 4) \ 4

C1 = Batch * 4 + 1: C2 = C1 + 3

IF (FontCol(Batch).Red <> FontCol2.Red OR FontCol(Batch).Green <> FontCol2.Green OR FontCol(Batch).Blue <> FontCol2.Blue) THEN
   FontCol(Batch) = FontCol2
   REDIM Temp2(C1 TO C2) AS Colour
   FOR t = C1 TO C2
      Temp2(t).Red = FontCol(Batch).Red * FontPal(FontPC(Batch), t - Batch * 4)
      Temp2(t).Green = FontCol(Batch).Green * FontPal(FontPC(Batch), t - Batch * 4)
      Temp2(t).Blue = FontCol(Batch).Blue * FontPal(FontPC(Batch), t - Batch * 4)
   NEXT t
   SetPalette Temp2(), C1, C2
END IF

IF x2 = 0 THEN x2 = 319
IF y2 = 0 THEN y2 = 199
x2 = x2 - 7: y2 = y2 - 7
X = x1: Y = y1

REDIM WordLen(100) AS INTEGER
WordPos = 1

FOR t = 1 TO LEN(Message)
   A = ASC(MID$(Message, t, 1)) - 32
   IF A >= 1 AND A <= 95 THEN
      WordLen(WordPos) = WordLen(WordPos) + FontWidth(A) + 2
   ELSEIF A = 0 THEN
      WordPos = WordPos + 1
   END IF
NEXT t

WordPos = 1
FOR t = 1 TO LEN(Message)
   A = ASC(MID$(Message, t, 1)) - 32
   IF A >= 0 AND A <= 95 THEN
      PUT (X, Y), FontPics(A * 34 + Batch * 3264), PSET
      X = X + FontWidth(A) + 2
   END IF
   IF A = 0 THEN
      WordPos = WordPos + 1
      IF x2 - X < WordLen(WordPos) THEN
         Y = Y + 8: X = x1
         IF Y > y2 THEN STOP
      END IF
   END IF
NEXT t


END SUB

FUNCTION ValidShot (t AS INTEGER) STATIC

IF Shots1(t).p <> 0 AND Shots1(t).p < 7 THEN ValidShot = 1 ELSE ValidShot = 0

END FUNCTION

SUB VPutINT (x1 AS INTEGER, y1 AS INTEGER, A() AS INTEGER, el AS LONG, Mode AS INTEGER, MinY AS INTEGER, MaxY AS INTEGER)

IF MinY > MaxY THEN SWAP MinY, MaxY
IF MinY < 0 THEN MinY = 0
IF MaxY > 199 THEN MaxY = 199

DIM SizeData(1 TO 2) AS STRING * 2
DIM NewPosWord(1 TO 2) AS STRING * 2
DIM XSize AS INTEGER, YSize AS INTEGER
DIM NewEl AS INTEGER, Newy1 AS INTEGER
DIM NewYSize AS INTEGER

SizeData(1) = MKI$(A(el))
SizeData(2) = MKI$(A(el + 1))

XSize = (ASC(MID$(SizeData(1), 1, 1)) + 256 * ASC(MID$(SizeData(1), 2, 1))) \ 8
YSize = ASC(MID$(SizeData(2), 1, 1)) + 256 * ASC(MID$(SizeData(2), 2, 1))

IF y1 < MinY THEN
   NewYSize = y1 + YSize - MinY
   IF NewYSize <= MinY THEN EXIT SUB
   SizeData(2) = MKI$(NewYSize)
   NewEl = el - (XSize \ 2) * (y1 - MinY)
   NewPosWord(1) = MKI$(A(NewEl))
   NewPosWord(2) = MKI$(A(NewEl + 1))
   Newy1 = MinY
   A(NewEl) = CVI(SizeData(1))
   A(NewEl + 1) = CVI(SizeData(2))
ELSE
   NewEl = el
   NewYSize = YSize
   Newy1 = y1
   NewPosWord(1) = MKI$(A(NewEl))
   NewPosWord(2) = MKI$(A(NewEl + 1))
END IF


yExtra = Newy1 + NewYSize - MaxY - 1
IF yExtra > 0 THEN
   SizeData(1) = MKI$(A(NewEl))
   SizeData(2) = MKI$(A(NewEl + 1))
   NewYSize = NewYSize - yExtra
   IF NewYSize <= 0 THEN EXIT SUB
   SizeData(2) = MKI$(NewYSize)
   A(NewEl) = CVI(SizeData(1))
   A(NewEl + 1) = CVI(SizeData(2))
END IF

SELECT CASE Mode
   CASE 1
      PUT (x1, Newy1), A(NewEl), PSET
   CASE 2
      PUT (x1, Newy1), A(NewEl), PRESET
   CASE 3
      PUT (x1, Newy1), A(NewEl), AND
   CASE 4
      PUT (x1, Newy1), A(NewEl), OR
   CASE ELSE
      PUT (x1, Newy1), A(NewEl), XOR
END SELECT


A(NewEl) = CVI(NewPosWord(1))
A(NewEl + 1) = CVI(NewPosWord(2))



END SUB

